         title   FileMan

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  FileMan.inc
            include  TreeList.asm
            include  FileOper.asm
            include  Options.asm
            include  LoadImageFile.asm

;rundll32 shell32.dll,control_rundll c:\winnt\system32\filename.cpl

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

;----- [Initialize the Component Object Model(COM) library] -----
      INVOKE     CoInitialize, 0
        test     eax, eax              ; Any HRESULT with the MSB (the sign bit) = 1, is an error
          js     NoGo                  ; js = jump if signed

      INVOKE     LoadLibrary, addr szCustListDLL ; Load the CustList.dll
         mov     hCustListDLL, eax
      .if !eax
         INVOKE     MessageBox, NULL, addr szError1, addr AppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif
        call     InitCommonControls

;----- [Get global IMalloc object] -----
      INVOKE     SHGetMalloc, addr pShellMalloc  ; Pointer to IMalloc used in TreeView
         cmp     eax, E_FAIL
          jz     Shutdown

      INVOKE     GetProcessHeap
         mov     hDefHeap, eax

      INVOKE     WinMain, hInst ,NULL, CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax

;        push     pShellMalloc
;         mov     eax, pShellMalloc
;         mov     eax, [eax]
;        call     [eax].IMalloc.Free ;Release
;      COVOKE     pShellMalloc, IMalloc, Free, pShellMalloc ;IUnknown, Release ;Free
      COVOKE     pShellMalloc, IMalloc, Release

Shutdown:
;----- [Close the COM library] -----
        call     CoUninitialize
      INVOKE     FreeLibrary, hCustListDLL

NoGo:
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain PROC uses ebx hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hInst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, hInst, 8003
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

         mov     lpcbData, 16
      INVOKE     RegQuerySZ, addr szWndPos, addr WndPos
      .if WndPos+8 > 100 && WndPos+12 > 100
            jmp     UseSavePos
      .endif

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 796
         shr     eax, 1
         mov     WndPos, eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 600
         shr     eax, 1
         mov     WndPos+4, eax
         mov     WndPos+8, 796
         mov     WndPos+12, 600

UseSavePos:
;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_ACCEPTFILES or WS_EX_APPWINDOW, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS,\
                 WndPos, WndPos+4, WndPos+8, WndPos+12, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd
      INVOKE     LoadAccelerators, hInst, IDR_ACCEL
         mov     hAccel, eax

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
         .break .if (!eax)
         INVOKE     TranslateAccelerator, hWnd, hAccel, addr msg
         .if eax == 0
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
         .endif
      .endw
         mov     eax, msg.wParam
         ret

WinMain ENDP

;===================================================
; WinProc procedure
;===================================================
WndProc PROC uses ebx esi edi hwnd:DWORD, wMsg, wParam, lParam
LOCAL    tbb:TBBUTTON
LOCAL    tbab:TBADDBITMAP
LOCAL    cm:COLORMAP
LOCAL    sfi:SHFILEINFO
LOCAL    sei:SHELLEXECUTEINFO
LOCAL    ShFileOp:SHFILEOPSTRUCT
LOCAL    stin:STARTUPINFO
LOCAL    prin:PROCESS_INFORMATION
LOCAL    nmhdr:NMHDR
LOCAL    nmtree:NM_TREEVIEW
LOCAL    pt:POINT
LOCAL    rect:RECT
LOCAL    bSize:DWORD, hTbBmp, ID, Cnt, hDC, SelOn, Val, hReg, hBRM, htbmp, TempDC
LOCAL    szBuff[64]:BYTE, szBuff1[256]:BYTE
LOCAL    pidl:LPITEMIDLIST

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE
            mov     eax, hwnd
            mov     hWnd, eax

         INVOKE     LoadLibrary, addr szShell32
            mov     hShell32, eax
         .if (eax > 32)
            INVOKE     GetProcAddress, hShell32, 2
               mov     lpSHChangeNotifyRegister, eax
            INVOKE     GetProcAddress, hShell32, 4
               mov     lpSHChangeNotifyUnregister, eax
            INVOKE     GetProcAddress, hShell32, addr szSHParse
               mov     lpfnSHParseDisplayName, eax
         .endif
         INVOKE     FreeLibrary, hShell32

         .if lpSHChangeNotifyRegister
            INVOKE     SHGetSpecialFolderLocation, hWnd, CSIDL_DESKTOP, addr pidl
            INVOKE     lpSHChangeNotifyRegister, hWnd, 2,\
                       SHCNE_ALLEVENTS, WM_SHNOTIFY, 1, addr pidl
               mov     hSHNotify, eax
            COVOKE     pShellMalloc, IMalloc, Free, pidl
         .endif

            mov     NumColumns, 6
         INVOKE     lstrcpy, addr Column01, addr szNameCol
         INVOKE     lstrcpy, addr Column02, addr szExtCol
         INVOKE     lstrcpy, addr Column03, addr szSizeCol
         INVOKE     lstrcpy, addr Column04, addr szDateCol
         INVOKE     lstrcpy, addr Column05, addr szAttrCol
         INVOKE     lstrcpy, addr Column06, addr szNull
            mov     ColWth[0], 144
            mov     ColWth[4], 30
            mov     ColWth[8], 60
            mov     ColWth[12], 110
            mov     ColWth[16], 30
            mov     ColWth[20], 0
            mov     TextLen01, 128
            mov     TextLen02, 6
            mov     TextLen03, 12
            mov     TextLen04, 32
            mov     TextLen05, 6
            mov     TextLen06, 8
            mov     SortL, 0
            mov     SortL+4, 0
            mov     SortR, 0
            mov     SortR+4, 0
            mov     ShowGrid, 1
            mov     ViewFlag, 309
            mov     EqualOn, 1
            mov     ShowConfC, 1
            mov     ShowConfD, 1
            mov     ShowProgess, 1
           call     Initialize
mov     Test44, 500
         .if !szListPathL || szListPathL == ' '
            INVOKE     GetCurrentDirectory, lengthof szBuff, addr szBuff
            INVOKE     lstrcat, addr szBuff, addr szSlashB
            INVOKE     lstrcpy, addr szListPathL, addr szBuff
            INVOKE     lstrcpy, addr szListPathR, addr szBuff
               mov     ActiveList, 0
         .endif

         INVOKE     LoadCursor, hInst, 9007
            mov     hSplit, eax
         INVOKE     LoadCursor, hInst, 9008
            mov     hDrag, eax
         INVOKE     LoadCursor, hInst, 9009
            mov     hDrop, eax

;---------- [Create the Fonts] ----------
         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameTac
            mov     lf.lfHeight, -11
            mov     lf.lfWeight, 600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontC, eax    ; Column font

            mov     lf.lfHeight, -9
            mov     lf.lfWeight, 500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontS, eax    ; Small font

         INVOKE     lstrcpy, addr lf.lfFaceName, addr FontNameMS
            mov     lf.lfHeight, -9 ;-12
            mov     lf.lfWeight, 600 ;500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontL, eax    ; Listbox font

            mov     lf.lfHeight, -9
            mov     lf.lfWeight, 500
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontM, eax    ; Menu font

            mov     lf.lfHeight, -12
            mov     lf.lfWeight, 600
         INVOKE     CreateFontIndirect, addr lf
            mov     hFontT, eax    ; Toolbar font

;---------- [Create the status bar window
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or WS_CLIPSIBLINGS or SBS_SIZEGRIP,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
            mov     hWndStat, eax

;---------- Copy, Rename, Delete, Make Dir, Find, Exit toolbars
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,\
                    0, 0, 600, 25, hwnd, 20, hInst, 0 ;375
            mov     hWndTool, eax
         INVOKE     SendMessage, hWndTool, WM_SETFONT, hFontT, TRUE

         INVOKE     SendMessage, hWndTool, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
            mov     eax, 00100000h  ;00a0032h
         INVOKE     SendMessage, hWndTool, TB_SETBITMAPSIZE, 0, eax

;          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt1
         TBButt     hWndTool, 0, IDM_COPY, eax
          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt2
         TBButt     hWndTool, 0, IDM_MOVE, eax
          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt3
         TBButt     hWndTool, 0, IDM_RENAME, eax
          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt4
         TBButt     hWndTool, 0, IDM_DELETE, eax
          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt5
         TBButt     hWndTool, 0, IDM_MAKEDIR, eax
          TBSep     hWndTool
         INVOKE     SendMessage, hWndTool, TB_ADDSTRING, 0, addr Butt6
         TBButt     hWndTool, 0, IDM_FIND, eax
          TBSep     hWndTool

         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            dec     eax
            mov     ecx, eax
         INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
           push     rect.right
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,\
                    rect.right, 0, 1200, 25, hwnd, 21, hInst, 0
            mov     hWndToolE, eax
         INVOKE     SendMessage, hWndToolE, WM_SETFONT, hFontT, TRUE

;---------- [Create the Exit ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 8, 0
            mov     hImageListT, eax
         INVOKE     LoadBitmap, hInst, 8001           ; Exit
            mov     hTbBmp, eax
         INVOKE     ChgBmpColor, hTbBmp
            mov     hTbBmp, eax

         INVOKE     ImageList_Add, hImageListT, hTbBmp, NULL
         INVOKE     DeleteObject, hTbBmp

         INVOKE     SendMessage, hWndToolE, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0

            mov     eax, 00100000h  ;00a0032h
         INVOKE     SendMessage, hWndToolE, TB_SETBITMAPSIZE, 0, eax
         INVOKE     SendMessage, hWndToolE, TB_SETIMAGELIST, 0, hImageListT

         INVOKE     SendMessage, hWndToolE, TB_ADDSTRING, 0, addr Exit
         TBButt     hWndToolE, 0, IDM_EXIT, eax
          TBSep     hWndToolE

         INVOKE     SendMessage, hWndToolE, TB_GETITEMRECT, 0, addr rect
            pop     eax
            add     eax, 10
            add     rect.right, eax
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or TBSTYLE_LIST or TBSTYLE_WRAPABLE,\
                    rect.right, 0, 1200, 25, hwnd, 22, hInst, 0
            mov     hWndToolN, eax

;---------- [Create the Note-Paint-etc. ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 4, 0
            mov     hImageListN, eax
            mov     esi, 9001
            mov     ebx, 5
         .while (ebx)
            INVOKE     LoadIcon, hInst, esi
              push     eax
            INVOKE     ImageList_AddIcon, hImageListN, eax
               pop     eax
            INVOKE     DestroyIcon, eax
               inc     esi
               dec     ebx
         .endw
         INVOKE     SendMessage, hWndToolN, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0

            mov     eax, 00100000h
         INVOKE     SendMessage, hWndToolN, TB_SETBITMAPSIZE, 0, eax
         INVOKE     SendMessage, hWndToolN, TB_SETIMAGELIST, 0, hImageListN
         TBButt     hWndToolN, 0, 710, 0
         TBButt     hWndToolN, 1, 711, 0
         TBButt     hWndToolN, 2, 712, 0
         TBButt     hWndToolN, 3, 713, 0
         TBButt     hWndToolN, 4, 714, 0

;---------- [Create the drive toolbar window
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or CCS_ADJUSTABLE or TBSTYLE_FLAT or TBSTYLE_LIST,\
                    0, 24, 1200, 24, hwnd, 41, hInst, 0
            mov     hWndDrives, eax

;---------- [Create the ImageList] ----------
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 9, 12
            mov     hImageListD, eax

            mov     cm.From, 00d08080h
         INVOKE     GetSysColor, COLOR_BTNFACE
            mov     cm.To, eax
         INVOKE     CreateMappedBitmap, hInst, 8002, 0, addr cm, 1
           push     eax
         INVOKE     ImageList_Add, hImageListD, eax, NULL
            pop     eax
;;;;         INVOKE     DeleteObject, eax
         INVOKE     SendMessage, hWndDrives, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hWndDrives, TB_SETIMAGELIST, 0, hImageListD
            mov     eax, 0010000fh                            ; hword = height, lword = width
         INVOKE     SendMessage, hWndDrives, TB_SETBITMAPSIZE, 0, eax
         INVOKE     SendMessage, hWndDrives, WM_SETFONT, hFontC, TRUE

;---------- [Find available drives
            and     NumDrives, 0
         INVOKE     GetLogicalDrives
            mov     ebx, eax
            xor     esi, esi
            xor     edi, edi
         .while (ebx)
            INVOKE     GetDriveType, addr szDriveType    ; Get type of drive

;---------- [Add the drive letter to the array
            .if eax == DRIVE_REMOVABLE || eax == DRIVE_FIXED || eax == DRIVE_CDROM ||\
                eax == DRIVE_REMOTE || eax == DRIVE_RAMDISK
                  mov     ecx, eax
               .if ecx == DRIVE_REMOVABLE && byte ptr szDriveType < 'c'
                     mov     ecx, 0
               .elseif ecx == DRIVE_REMOVABLE && byte ptr szDriveType > 'b'
                     mov     ecx, 2
               .elseif ecx == DRIVE_FIXED
                     inc     NumDrives
                     mov     ecx, 1
               .elseif ecx == DRIVE_CDROM
                     mov     ecx, 3
               .elseif ecx == DRIVE_REMOTE
                     mov     ecx, 4
               .elseif ecx == DRIVE_RAMDISK
                     mov     ecx, 5
               .endif
                  mov     DriveArrayI[edi*4], ecx   ; Image ID
                  mov     al, byte ptr szDriveType
                  mov     DriveArrayL[edi], al      ; Drive letter
                  inc     esi
                  inc     edi
            .endif
               inc     szDriveType
               shr     ebx, 1
         .endw

            mov     DriveArrayL[edi], 0
            xor     edi, edi
            mov     ebx, 1000
         .while (esi)
            INVOKE     lstrcpyn, addr szWork, addr DriveArrayL[edi], 2
               mov     eax, DriveArrayI[edi*4]
               inc     eax
            TBButt     hWndDrives, eax, ebx, offset szWork
               inc     ebx
               inc     edi
               dec     esi
         .endw
            mov     eax, 000000020h
         INVOKE     SendMessage, hWndDrives, TB_SETBUTTONSIZE, 0, eax

;---------- [Combo Boxes
         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE,
                    0, 48, 1200, 24, hwnd, 1, hInst, NULL
            mov     hWndToolC, eax

         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset ComboClass, 0,
                    WS_CHILD or WS_VSCROLL or WS_VISIBLE or WS_CLIPSIBLINGS or CBS_HASSTRINGS or\
                    CBS_NOINTEGRALHEIGHT or CBS_DROPDOWN or WS_BORDER,
                    3, 0, 50, 450, hWndToolC, 42, hInst, 0
            mov     hComboL, eax

         INVOKE     SendMessage, hComboL, CB_DIR, DDL_DRIVES or DDL_EXCLUSIVE, addr szAllFiles
         INVOKE     SendMessage, hComboL, CB_SETCURSEL, 1, 0
         INVOKE     SendMessage, hComboL, CB_SETITEMHEIGHT, -1, 15
         INVOKE     SendMessage, hComboL, CB_SETITEMHEIGHT, 1, 15

         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, offset ComboClass, 0,
                    WS_CHILD or WS_VSCROLL or WS_VISIBLE or WS_CLIPSIBLINGS or CBS_HASSTRINGS or\
                    CBS_NOINTEGRALHEIGHT or CBS_DROPDOWN or WS_BORDER,
                    396, 0, 50, 450, hWndToolC, 43, hInst, 0
            mov     hComboR, eax

         INVOKE     SendMessage, hComboR, CB_DIR, DDL_DRIVES or DDL_EXCLUSIVE, addr szAllFiles
         INVOKE     SendMessage, hComboR, CB_SETCURSEL, 1, 0
         INVOKE     SendMessage, hComboR, CB_SETITEMHEIGHT, -1, 15
         INVOKE     SendMessage, hComboR, CB_SETITEMHEIGHT, 1, 15

;---------- [Static Windows
         INVOKE     CreateWindowEx, 0, addr StaticClass, addr szNiceDay,
                    WS_CHILD or WS_VISIBLE or SS_CENTER,
                    0, 0, 0, 0, hWnd, 51, hInst, 0
            mov     hStaticT, eax
         INVOKE     SendMessage, hStaticT, WM_SETFONT, hFontC, TRUE

         INVOKE     CreateWindowEx, 0, addr StaticClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or CCS_NOPARENTALIGN or CCS_NORESIZE,
                    55, 4, 200, 20, hWndToolC, 52, hInst, 0
            mov     hStaticL, eax
         INVOKE     SendMessage, hStaticL, WM_SETFONT, hFontC, TRUE
         INVOKE     SetWindowText, hStaticL, addr ToolClass

         INVOKE     CreateWindowEx, 0, addr StaticClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or CCS_NOPARENTALIGN or CCS_NORESIZE,
                    450, 4, 200, 20, hWndToolC, 53, hInst, 0
            mov     hStaticR, eax
         INVOKE     SendMessage, hStaticR, WM_SETFONT, hFontC, TRUE
         INVOKE     SetWindowText, hStaticR, addr ToolClass

;---------- [Refresh Toolbars
         INVOKE     ImageList_Create,16,16,ILC_COLOR16 or ILC_MASK,1,2
            mov     hSingleImage, eax
         INVOKE     LoadIcon, hInst, 9006         ; Refresh icon
           push     eax
         INVOKE     ImageList_AddIcon, hSingleImage, eax
            pop     eax
         INVOKE     DestroyIcon, eax

         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or TBSTYLE_FLAT or TBSTYLE_LIST,
                    3, -2, 70, 24, hWndToolC, 2000, hInst,NULL
            mov     hToolBarL, eax

         INVOKE     SendMessage, hToolBarL, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hToolBarL, TB_SETIMAGELIST, 0, hSingleImage
            mov     eax, 000f0010h
         INVOKE     SendMessage, hToolBarL, TB_SETBITMAPSIZE, 0, eax
            mov     eax, 000f0032h
         INVOKE     SendMessage, hToolBarL, TB_SETBUTTONSIZE, 0, eax
         INVOKE     SendMessage, hToolBarL, TB_ADDSTRING, 0, addr szRefresh
         TBButt     hToolBarL, 0, 2000, 0

         INVOKE     CreateWindowEx, 0, addr ToolClass, 0,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or TBSTYLE_TOOLTIPS or CCS_NOPARENTALIGN or\
                    CCS_NORESIZE or TBSTYLE_FLAT or TBSTYLE_LIST,
                    396, -2, 70, 24, hWndToolC, 2001, hInst,NULL
            mov     hToolBarR, eax

         INVOKE     SendMessage, hToolBarR, TB_BUTTONSTRUCTSIZE, sizeof TBBUTTON, 0
         INVOKE     SendMessage, hToolBarR, TB_SETIMAGELIST, 0, hSingleImage
            mov     eax, 000f0010h
         INVOKE     SendMessage, hToolBarR, TB_SETBITMAPSIZE, 0, eax
            mov     eax, 000f0032h
         INVOKE     SendMessage, hToolBarR, TB_SETBUTTONSIZE, 0, eax
         INVOKE     SendMessage, hToolBarR, TB_ADDSTRING, 0, addr szRefresh
         TBButt     hToolBarR, 0, 2001, 0

;---------- [Create the Selection bars
         INVOKE     CreateWindowEx, NULL, addr StaticClass, NULL,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_GRAYRECT,\
                    0, 0, 0, 0, hwnd, 2009, hInst, NULL
            mov     hFill, eax

         INVOKE     CreateWindowEx, NULL, addr StaticClass, NULL,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_OWNERDRAW or SS_NOTIFY,\
                    0, 72, 0, 18, hwnd, 2009, hInst, NULL
            mov     hSelBarT, eax

         INVOKE     CreateWindowEx, NULL, addr StaticClass, NULL,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_OWNERDRAW or SS_NOTIFY,\
                    0, 72, 0, 18, hwnd, 2010, hInst, NULL
            mov     hSelBarL, eax

         INVOKE     CreateWindowEx, NULL, addr StaticClass, NULL,
                    WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_OWNERDRAW or SS_NOTIFY,\
                    0, 72, 0, 18, hwnd, 2011, hInst, NULL
            mov     hSelBarR, eax

         INVOKE     lstrcpy, addr szBuff1, CommandLine
         .if byte ptr szBuff1 == '"'
            INVOKE     lstrcpy, addr szBuff1, addr szBuff1+1
            INVOKE     lstrlen, addr szBuff1
            .while (eax)
               .if byte ptr szBuff1[eax] == '\'
                  .break
               .endif
                  dec     eax
            .endw
               inc     eax
            INVOKE     lstrcpyn, addr szPathName, addr szBuff1, eax

         .else
            INVOKE     GetCurrentDirectory, lengthof szPathName, addr szPathName
         .endif
         INVOKE     lstrcat, addr szPathName, addr szSlashB

         INVOKE     GetCurrentDirectory, sizeof szBuff1, addr szBuff1
         INVOKE     SHGetFileInfo, addr szBuff1, 0, addr sfi, sizeof SHFILEINFO,\
                    SHGFI_SYSICONINDEX or SHGFI_ICON or SHGFI_SMALLICON
            mov     hImageList, eax
           call     GetImageID

         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 300
            mov     hBuff, eax
         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 6912
            mov     hPathL, eax
         INVOKE     HeapAlloc, hDefHeap, HEAP_ZERO_MEMORY, 6912
            mov     hPathR, eax

         INVOKE     InitTree, 0, 0
           push     ActiveList
            mov     ActiveList, 0
           call     CreateList
         INVOKE     SendMessage, hWndListL, WM_SETFONT, hFontL, TRUE
           call     AddColumns
           call     SetColorFont
           call     LoadFiles
            mov     ActiveList, 1
           call     CreateList
         INVOKE     SendMessage, hWndListR, WM_SETFONT, hFontL, TRUE
           call     AddColumns
           call     SetColorFont 
           call     LoadFiles
            pop     ActiveList
           call     ChkTool
           push     ActiveList
            xor     ActiveList, 1
           call     TreeBranch
            pop     ActiveList
           call     TreeBranch

         INVOKE     SendMessage, hSelBarL, WM_SETFONT, hFontC, TRUE
         INVOKE     SendMessage, hSelBarR, WM_SETFONT, hFontC, TRUE

            and     SelBarMask, 0
            xor     ecx, ecx
         .while (ecx < 4)
            .if byte ptr Color.SelBarF[ecx] == 0ffh
                  mov     byte ptr Color.SelBarF[ecx], 0feh
                  mov     SelBarMask, 00010101h
            .endif
            .if byte ptr Color.SelBarF[ecx]
               mov     byte ptr SelBarMask[ecx], 1
         .endif
            inc     ecx
         .endw
         .if !SelBarMask
               mov     SelBarMask, 00010101h
         .endif

;---------- [Set handles] ----------
            mov     eax, hwnd
            mov     Hand.hWnd, eax
            mov     eax, hWndStat
            mov     Hand.hWndStat, eax
            mov     eax, hWndListL
            mov     Hand.hWndListL, eax
            mov     eax, hWndListR
            mov     Hand.hWndListR, eax
            mov     eax, hWndTree
            mov     Hand.hWndTree, eax
            mov     eax, hImageList
            mov     Hand.hImageList, eax
         INVOKE     SendMessage, hWndListL, CM_SETHANDLES, 0, addr Hand
            mov     eax, ActiveList
         INVOKE     SetFocus, hWndListL[eax*4]
            xor     eax, eax
         .if ViewFlag == 310 || ViewFlag == 312
               mov     eax, 1
         .endif
         INVOKE     SendMessage, hWndListL, CM_SETTREE, SplitV[4], eax

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE
            and     TreeviewOn, 0
         .if ViewFlag == 310 || ViewFlag == 312
               mov     TreeviewOn, 1
         .endif
         .if TreeviewOn
            INVOKE     ShowWindow, hStaticT, SW_SHOW
            INVOKE     ShowWindow, hSelBarT, SW_SHOW
            INVOKE     ShowWindow, hFill, SW_SHOW
            INVOKE     ShowWindow, hHeader, SW_SHOW
            INVOKE     ShowWindow, hWndTree, SW_SHOW
         .else
            INVOKE     ShowWindow, hStaticT, SW_HIDE
            INVOKE     ShowWindow, hSelBarT, SW_HIDE
            INVOKE     ShowWindow, hFill, SW_HIDE
            INVOKE     ShowWindow, hHeader, SW_HIDE
            INVOKE     ShowWindow, hWndTree, SW_HIDE
         .endif
         .if ViewFlag == 309 || ViewFlag == 310
            INVOKE     ShowWindow, hComboR, SW_SHOW
            INVOKE     ShowWindow, hStaticR, SW_SHOW
            INVOKE     ShowWindow, hSelBarR, SW_SHOW
            INVOKE     ShowWindow, hToolBarR, SW_SHOW
            INVOKE     ShowWindow, hWndListR, SW_SHOW
         .else
            INVOKE     ShowWindow, hComboR, SW_HIDE
            INVOKE     ShowWindow, hStaticR, SW_HIDE
            INVOKE     ShowWindow, hSelBarR, SW_HIDE
            INVOKE     ShowWindow, hToolBarR, SW_HIDE
            INVOKE     ShowWindow, hWndListR, SW_HIDE
         .endif

;---------- [Compute the splits] ----------
            mov     eax, lParam       ; Get width
            mov     edi, eax
            and     eax, 0ffffh       ; Lowword
            mov     ebx, eax
            shr     edi, 16           ; Height of new client area
            sub     edi, 110
         .if TreeviewOn
               sub     eax, SplitV[4]
               sub     eax, 2
         .endif
            shr     eax, 1            ; /2
            mov     ecx, eax          ; Save factor

            mov     SplitV[24], ecx
            mov     SplitV[28], ecx

         .if TreeviewOn
               mov     edx, SplitV[4]
               mov     SplitV[8], edx
               add     SplitV[8], 2
            .if EqualOn
                  mov     SplitV[12], edx
                  add     SplitV[12], 2
                  add     SplitV[12], ecx
                  mov     edx, SplitV[12]
                  mov     SplitV[16], edx
                  add     SplitV[16], 2
                  mov     edx, SplitV[16]
                  mov     SplitV[20], edx
                  add     SplitV[20], ecx
               .if ViewFlag == 312
                     sub     ebx, SplitV[4]
                     mov     SplitV[24], ebx
                     mov     SplitV[28], 0
               .else
                     add     SplitV[28], 1
               .endif

            .else
                  mov     edx, SplitV[12]
                  sub     edx, SplitV[8]
                  mov     SplitV[24], edx
                  mov     edx, SplitV[20]
                  sub     edx, SplitV[16]
                  mov     SplitV[28], edx
                  sub     ebx, SplitV[4]
                  sub     ebx, 2
               .if ViewFlag == 312
                     add     ebx, 2
                     mov     SplitV[24], ebx
                     mov     SplitV[28], 0
               .else
                     sub     ebx, SplitV[24]
                     mov     SplitV[28], ebx
               .endif
            .endif
;SplitV        dd  0, 163, 165, 476, 478, 789, 311, 311
;SplitV        dd  0, 163, 0, 394, 396, 790, 394, 394
; 309 = Two List views
; 310 = Tree view and Two list views
; 311 = One list view
; 312 = Tree view and One list view

         .else
               mov     SplitV[8], 0
            .if EqualOn
               .if ViewFlag == 309
                     mov     SplitV[12], ecx
                     mov     SplitV[16], ecx
                     add     SplitV[16], 2
                     mov     edx, SplitV[16]
                     mov     SplitV[20], edx
                     add     SplitV[20], ecx
               .else
                     mov     SplitV[12], ebx
                     add     ebx, 2
                     mov     SplitV[24], ebx
                     mov     SplitV[28], 0
               .endif

            .else
               .if ViewFlag == 309
                     mov     edx, SplitV[12]
                     mov     SplitV[24], edx
                     sub     edx, SplitV[8]
                     mov     SplitV[16], edx
                     add     SplitV[16], 2
                     sub     ebx, SplitV[16]
                     add     ebx, 2
                     mov     SplitV[28], ebx
               .else
                     add     ebx, 2
                     mov     SplitV[24], ebx
                     mov     SplitV[28], 0
               .endif
            .endif
         .endif

;---------- [Don't size if sizing listview splitter and equal size on
         .if BarType == 2 && EqualOn
               and     BarType, 0
               jmp     Ret0
         .endif

;---------- [Size the Statusbar Control
            mov     sbParts, 0
            mov     edx, 0
         .if TreeviewOn
             MOVmd     sbParts, SplitV[4] ; Part1
               add     edx, 2
         .endif
          MOVmd     sbParts[4], SplitV[24]
            mov     eax, sbParts
            add     eax, edx
            add     sbParts[4], eax       ; and also part2
          MOVmd     sbParts[8], SplitV[28]
            mov     eax, sbParts[4]
            add     sbParts[8], eax       ; and also part3, .. etc

;INVOKE     LockWindowUpdate, hWnd
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 3, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE
         INVOKE     SendMessage, hWndStat, SB_SETTEXT, 1, addr szStatusL
         INVOKE     SendMessage, hWndStat, SB_SETTEXT, 2, addr szStatusR

;---------- [Size the Toolbar Controls
         INVOKE     SendMessage, hWndTool, TB_BUTTONCOUNT, 0, 0
            dec     eax
            mov     ecx, eax
         INVOKE     SendMessage, hWndTool, TB_GETITEMRECT, ecx, addr rect
            mov     ebx, rect.right
         INVOKE     MoveWindow, hWndTool, 0, 0, rect.right, 25, TRUE
         INVOKE     SendMessage, hWndToolE, TB_GETITEMRECT, 0, addr rect
            add     rect.right, 10
         INVOKE     MoveWindow, hWndToolE, ebx, 0, rect.right, 25, TRUE
            add     rect.right, ebx
            mov     edx, lParam
            and     edx, 0ffffh
         INVOKE     MoveWindow, hWndToolN, rect.right, 0, edx, 24, TRUE
         INVOKE     SendMessage, hWndDrives, TB_AUTOSIZE, 0, 0

;---------- [Size the other Controls
         INVOKE     SetWindowPos, hComboL, HWND_NOTOPMOST, SplitV[8], 0, 0, 0, SWP_NOSIZE or SWP_NOZORDER
         INVOKE     SetWindowPos, hComboR, HWND_NOTOPMOST, SplitV[16], 0, 0, 0, SWP_NOSIZE or SWP_NOZORDER

            mov     ecx, SplitV[8]
            add     ecx, 55
            mov     edx, SplitV[24]
            sub     edx, 124
         INVOKE     MoveWindow, hStaticL, ecx, 4, edx, 20, TRUE
            mov     ecx, SplitV[16]
            add     ecx, 55
            mov     edx, SplitV[28]
            sub     edx, 124
            dec     edx
         INVOKE     MoveWindow, hStaticR, ecx, 4, edx, 20, TRUE

            mov     ecx, SplitV[24]
            dec     ecx
         INVOKE     MoveWindow, hSelBarL, SplitV[8], 71, ecx, 18, TRUE
            mov     ecx, SplitV[28]
            dec     ecx
;            dec     ecx
         INVOKE     MoveWindow, hSelBarR, SplitV[16], 71, ecx, 18, TRUE

         INVOKE     MoveWindow, hWndListL, SplitV[8], 89, SplitV[24], edi, TRUE
         INVOKE     MoveWindow, hWndListR, SplitV[16], 89, SplitV[28], edi, TRUE
         INVOKE     GetClientRect, hSelBarL, addr rect
            mov     ebx, rect.right
            sub     ebx, 65
         .if TreeviewOn
               add     ebx, SplitV[4]
               add     ebx, 2
         .endif
         .if ViewFlag == 311 || ViewFlag == 312
               sub     ebx, 1
         .endif
         INVOKE     MoveWindow, hToolBarL, ebx, -2, 68, 24, TRUE
         INVOKE     GetClientRect, hWnd, addr rect
            mov     ebx, rect.right
            sub     ebx, 65
         INVOKE     MoveWindow, hToolBarR, ebx, -2, 68, 24, TRUE
         INVOKE     GetWindowRect, hWnd, addr rect
           push     rect.left
           push     rect.top
         INVOKE     GetWindowRect, hWndListL, addr rect
            pop     eax
          MOVmd     dwTop, rect.top
            sub     dwTop, eax
            add     dwTop, 18                   ; Column header
            mov     ecx, rect.left
            sub     rect.right, ecx
            pop     eax
            sub     ecx, eax
            sub     ecx, 4
            add     rect.right, ecx
         INVOKE     SendMessage, hWndListL, CM_LEFTWIDTH, rect.right, 0

         .if TreeviewOn
               dec     SplitV[4]
            INVOKE     MoveWindow, hStaticT, 0, 54, SplitV[4], 16, TRUE
            INVOKE     MoveWindow, hSelBarT, 0, 71, SplitV[4], 18, TRUE
            INVOKE     MoveWindow, hFill, 0, 89, SplitV[4], 1, TRUE
            INVOKE     MoveWindow, hHeader, 0, 90, SplitV[4], 17, TRUE
               inc     SplitV[4]
               sub     edi, 17
            INVOKE     MoveWindow, hWndTree, 0, 106, SplitV[4], edi, TRUE
            INVOKE     SetWindowText, hStaticT, addr szNiceDay
            INVOKE     RedrawWindow, hStaticT, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
         .endif

         .if wParam == SIZE_MAXIMIZED
               mov     FillL, 1
               mov     FillR, 1
         .endif
         INVOKE     GetClientRect, hWnd, addr rect

;---------- [Chect to see if fill rows need to be refreshed
         .if FillL && rect.bottom || FillR && rect.bottom
              push     ActiveList
            .if FillL
                  mov     ActiveList, 0
                 call     Refresh
            .endif
            .if FillR
                  mov     ActiveList, 1
                 call     Refresh
            .endif
               pop     ActiveList
              call     ChkTool
            INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0
         .endif
;INVOKE     LockWindowUpdate, 0

      .elseif wMsg == WM_SYSCOMMAND
         .if wParam == SC_MINIMIZE
            INVOKE     GetClientRect, hWnd, addr rect
             MOVmd     WBottom, rect.bottom
            INVOKE     GetClientRect, hWndListL, addr rect
             MOVmd     LBottom, rect.bottom
         .endif
            jmp     DefWin

      .elseif wMsg == WM_SETFOCUS
            mov     eax, ActiveList
         INVOKE     SetFocus, hWndListL[eax*4]

      .elseif wMsg == WM_ACTIVATEAPP
            and     FileOper, 0
         INVOKE     DefWindowProc, hWnd, WM_NCACTIVATE, wParam, 0 
            ret

      .elseif wMsg == WM_NCACTIVATE
            mov     eax, TRUE 
            ret

      .elseif wMsg == WM_INITMENUPOPUP || wMsg == WM_ENTERMENULOOP || wMsg == WM_EXITMENULOOP
         .if pcm2
            .if wMsg == WM_INITMENUPOPUP
               INVOKE     vf(pcm2, IContextMenu2, HandleMenuMsg), wMsg, wParam, lParam
            .endif
         .endif

      .elseif wMsg == WM_SHNOTIFY
         .if !Funct && !FileOper
            INVOKE     DoSHNotify, wParam, lParam
         .endif

      .elseif wMsg == WM_NOTIFY
            mov     ebx, lParam                      ; Get pointer to NMHDR
            mov     eax, (NMHDR ptr [ebx]).code
            mov     edi, (NMHDR ptr [ebx]).hwndFrom

         .if eax == TTN_NEEDTEXT
               mov     eax, (NMHDR ptr [ebx]).idFrom ; Resource id
               mov     ebx, eax
            .if eax > 999 && eax < 1026

;---------- [Build the tool tips for the drive tool bars
                  sub     eax, 1000
                  mov     cl, byte ptr DriveArrayL[eax]
                  mov     byte ptr szRoot, cl
               INVOKE     SHGetFileInfo, addr szRoot, 0, addr sfi, sizeof SHFILEINFO,
                          SHGFI_DISPLAYNAME
               INVOKE     lstrcpy, addr szBuff, addr sfi.szDisplayName
            .else      
               INVOKE     LoadString, hInst, ebx, addr szBuff, lengthof szBuff
            .endif
               mov     ebx, lParam                   ; Get the buffer addr
               lea     eax, szBuff
               mov     (TOOLTIPTEXT ptr [ebx]).lpszText, eax
               jmp     Ret0

         .elseif edi == hWndTree && !DragFrTree ||\
                 edi == hWndTree && DragFrTree && !DragMode && eax == TVN_BEGINDRAG
            INVOKE     TreeNotify, lParam
               ret

         .elseif edi == hWndListL || edi == hWndListR || edi == hWndTree ;!edi && DragFrTree
               mov     eax, [ebx].NMHDR.code

;---------- [Set the active listview
            .if eax == CN_SETACTIVE || eax == CN_HEADERCLICK || eax == IDM_TAB
;                 push     ebx
;                 push     esi
                  and     GoBackOn, 0
                  and     FileOper, 0
                  mov     esi, hWndListL
                  mov     edx, ActiveList
                  mov     ActiveList, 0
               .if edi == hWndListR
                     mov     esi, hWndListR
                     mov     ActiveList, 1
               .endif
               .if edx != ActiveList
                    call     ChkButt
               .endif

                  and     ListSelS, 0
                  and     ListSelN, 0
                  mov     esi, ActiveList
               INVOKE     SendMessage, hWndListL[esi*4], CM_CHECKSELECT, 0, addr SelArray
                  mov     Cnt, eax
                  xor     edi, edi
               .while (Cnt)
                     mov     ebx, SelArray[edi*4]
                     shl     ebx, 16
                     mov     bx, 5
                  INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
                     and     Val, 0ffffh
                  .if Val == 3
                        mov     bx, 2
                     INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
                        mov     eax, Val
                        add     ListSelS, eax
                        inc     ListSelN
                  .endif
                     inc     edi
                     dec     Cnt
               .endw

               .if ActiveList == 0
                  INVOKE     StatusBar, ListSelS, ListTotSL, ListSelN, ListTotNL
               .else
                  INVOKE     StatusBar, ListSelS, ListTotSR, ListSelN, ListTotNR
               .endif
;                  pop     esi
;                  pop     ebx
            .endif

               mov     esi, hWndListL
            .if ActiveList
                  mov     esi, hWndListR
            .endif
               mov     ebx, lParam                      ; Get pointer to NMHDR
               mov     eax, [ebx].NMHDR.code

;---------- [Sort the grid by column, invert sorting order
            .if eax == CN_HEADERCLICK
               INVOKE     SendMessage, esi, CM_COLUMNSORT, [ebx].LISTNOTIFY.Col, SORT_INVERT
                  mov     eax, [ebx].LISTNOTIFY.Col
                  mov     edi, ActiveList
                  mov     SortL[edi*8], eax
               INVOKE     SendMessage, esi, CM_GETSORT, 0, 0
                  mov     SortL[edi*8+4], eax
                  jmp     Ret0

;---------- [Edit text before update
            .elseif eax == CN_BEFOREUPDATE
                  mov     ecx, [ebx].LISTNOTIFY.Row
                  shl     ecx, 16
               INVOKE     SendMessage, esi, CM_GETCELLDATA, ecx, addr szFileName
               .if !ActiveList
                  INVOKE     lstrcpy, addr szBuffFr, addr szListPathL
               .else
                  INVOKE     lstrcpy, addr szBuffFr, addr szListPathR
               .endif
               INVOKE     lstrcat, addr szBuffFr, addr szFileName
                  jmp     Ret0

;---------- [Edit text after update
            .elseif eax == CN_AFTERUPDATE && Funct != IDM_EXPLODE
;DSPValue hWnd, Funct, 1, 'm'
                  mov     ecx, [ebx].LISTNOTIFY.Row
                  shl     ecx, 16
               INVOKE     SendMessage, esi, CM_GETCELLDATA, ecx, addr szFileName
               .if !ActiveList
                  INVOKE     lstrcpy, addr szRootPath, addr szListPathL
               .else
                  INVOKE     lstrcpy, addr szRootPath, addr szListPathR
               .endif
               INVOKE     lstrcat, addr szRootPath, addr szFileName
                  mov     Funct, IDM_RENAMEE
                 call     DoFileOperation
               INVOKE     SendMessage, hWndListL, CM_REDRAW, 0, 0
               INVOKE     SendMessage, hWndListR, CM_REDRAW, 0, 0
                  jmp     Ret0

;---------- [Drag
            .elseif eax == CN_DRAG
                MOVmd     DragOn, [ebx].LISTNOTIFY.DragOn
               .if DragOn
                     and     DragFrTree, 0
               .endif
                  jmp     Ret0

;---------- [Drag and Drop
            .elseif eax == CN_DRAGDROP
                  mov     DropOn, 1
                MOVmd     HitList, [ebx].LISTNOTIFY.HitList
                MOVmd     HitRow, [ebx].LISTNOTIFY.HitRow
;DSPValue hWnd, HitList, 1, 't'
               INVOKE     SendMessage, hWnd, WM_COMMAND, IDM_COPY, 0
                  and     DragFrTree, 0
                  jmp     Ret0

;---------- [Right button down
            .elseif eax == CN_BEFORESELCHANGE && [ebx].LISTNOTIFY.RButt
                  mov     ecx, [ebx].LISTNOTIFY.Row
                  mov     SavRow, ecx
                  shl     ecx, 16
               INVOKE     SendMessage, esi, CM_GETCELLDATA, ecx, addr szFileName
                  mov     eax, [ebx].LISTNOTIFY.FileTyp
                  mov     FileTyp, eax
               .if !ActiveList
                  INVOKE     lstrcpy, addr szRootPath, addr szListPathL
               .else
                  INVOKE     lstrcpy, addr szRootPath, addr szListPathR
               .endif
               INVOKE     lstrcat, addr szRootPath, addr szFileName
               INVOKE     PathToPidl, 0  ;ContextMenu2 ;PathToPidl ;ContextMenu
                  jmp     Ret0

;---------- [Left button double click
            .elseif eax == CN_BEFORESELCHANGE && [ebx].LISTNOTIFY.DBClick
                  mov     ecx, [ebx].LISTNOTIFY.Row
                  shl     ecx, 16
               INVOKE     SendMessage, esi, CM_GETCELLDATA, ecx, addr szBuff1
               .if [ebx].LISTNOTIFY.FileTyp == 1  ; Collapse directory
                  .if !ActiveList
                     INVOKE     lstrcpy, addr szRootPath, addr szListPathL
                       call     RemFileName
                     INVOKE     lstrcpy, addr szListPathL, addr szRootPath
                  .else
                     INVOKE     lstrcpy, addr szRootPath, addr szListPathR
                       call     RemFileName
                     INVOKE     lstrcpy, addr szListPathR, addr szRootPath
                  .endif
                     mov     GoBackOn, 1
                    call     TreeBranch
                     and     GoBackOn, 0
                    call     Refresh
               .endif

               .if [ebx].LISTNOTIFY.FileTyp == 2  ; Expand directory
                  .if !ActiveList
                     INVOKE     lstrcat, addr szListPathL, addr szBuff1
                     INVOKE     lstrcat, addr szListPathL, addr szSlashB
                  .else
                     INVOKE     lstrcat, addr szListPathR, addr szBuff1
                     INVOKE     lstrcat, addr szListPathR, addr szSlashB
                  .endif
                    call     TreeBranch
                    call     Refresh
               .endif

               .if [ebx].LISTNOTIFY.FileTyp == 3  ; File type
                  .if !ActiveList
                     INVOKE     lstrcpy, addr szRootPath, addr szListPathL
                  .else
                     INVOKE     lstrcpy, addr szRootPath, addr szListPathR
                  .endif
                  INVOKE     SetCurrentDirectory, addr szRootPath
                  INVOKE     lstrcat, addr szRootPath, addr szBuff1
                  INVOKE     ShellExecute, hWnd, addr szOpen, addr szRootPath, NULL, NULL, SW_SHOWNORMAL
                  .if eax < 33
                     INVOKE     lstrcpy, addr szBuff1, addr szChoosePgm
                     INVOKE     lstrcat, addr szBuff1, addr szRootPath
                     INVOKE     WinExec, addr szBuff1, SW_SHOWNORMAL     ; Choose a program
                  .endif
               .endif
                  jmp     Ret0
            .endif
         .endif
            jmp     DefWin

      .elseif wMsg == WM_PAINT
         INVOKE     SetWindowText, hStaticT, addr szNiceDay
         INVOKE     RedrawWindow, hStaticT, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
         INVOKE     RedrawWindow, hHeader, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT or RDW_UPDATENOW
         INVOKE     RedrawWindow, hSelBarT, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT or RDW_UPDATENOW
         INVOKE     RedrawWindow, hSelBarL, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT or RDW_UPDATENOW
         INVOKE     RedrawWindow, hSelBarR, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT or RDW_UPDATENOW
            jmp     DefWin

      .elseif wMsg == WM_MEASUREITEM
         .if wParam == 0               ; 0 = Menu
               mov     edx, lParam     ; Get pointer to MEASUREITEMSTRUCT
               mov     ebx, (MEASUREITEMSTRUCT ptr [edx]).itemID
            .if ebx != ImageID
                  mov     eax, 100
               .if PaintOn
                     mov     eax, 150
               .endif
                  mov     (MEASUREITEMSTRUCT ptr [edx]).itemWidth, eax
                  mov     (MEASUREITEMSTRUCT ptr [edx]).itemHeight, 18

            .else
                  mov     esi, pWidth
                  mov     edi, pHeight
                  add     esi, 5
                  add     edi, 5
                  mov     (MEASUREITEMSTRUCT ptr [edx]).itemWidth, esi
                  mov     (MEASUREITEMSTRUCT ptr [edx]).itemHeight, edi
            .endif
            .if pcm2 && ebx != ImageID
               INVOKE     vf(pcm2, IContextMenu2, HandleMenuMsg), wMsg, wParam, lParam
            .endif
         .endif
            mov     eax, 1
            ret

      .elseif wMsg == WM_DRAWITEM
         .if pcm2
            INVOKE     vf(pcm2, IContextMenu2, HandleMenuMsg), wMsg, wParam, lParam
         .endif
;         .if Funct || hSplitBar ;|| FileOper                    ; Don't draw if function operations
         .if hSplitBar || NotifyOn                    ; Don't draw if function operations
               jmp     Ret0
         .endif
            mov     esi, lParam
            lea     edi, dis
            mov     ecx, sizeof dis
            rep     movsb
            mov     eax, dis.hwndItem
         .if eax == hSelBarL || eax == hSelBarR || eax == hSelBarT
            .if eax == hSelBarL && ActiveList == 0 ||\
                eax == hSelBarR && ActiveList == 1 ||\
                eax == hSelBarT
                  mov     SelOn, 1
                  mov     ebx, 2
                  mov     esi, Color.SelBarF
               .if ViewFlag == 311
                     mov     ebx, 5
               .endif
               .if ViewFlag == 312
                     mov     ebx, 4
               .endif
               .if eax == hSelBarT
                     mov     ebx, 1
               .endif
            .else
                  and     SelOn, 0
                  mov     ebx, 5
                  mov     esi, 00808080h
            .endif
            .if eax == hSelBarL
               INVOKE     lstrcpy, addr szBuff1, addr szPathL
            .elseif eax == hSelBarR
               INVOKE     lstrcpy, addr szBuff1, addr szPathR
            .else
                  mov     szBuff1, 0
            .endif
               xor     edi, edi
            INVOKE     SetBkMode, dis.hdc, OPAQUE
            INVOKE     CopyRect, addr rect, addr dis.rcItem
               mov     rect.left, 0
               mov     rect.right, 0

DoAgain:
               add     rect.right, ebx
            INVOKE     CreateSolidBrush, esi
              push     eax
            INVOKE     FillRect, dis.hdc, addr rect, eax
               add     rect.left, ebx
               pop     eax
            INVOKE     DeleteObject, eax
            INVOKE     GetSysColor, COLOR_INACTIVECAPTIONTEXT
            INVOKE     SetTextColor, dis.hdc, eax
            .if SelOn
                  add     esi, SelBarMask
                  mov     Val, esi
                  xor     ecx, ecx
               .while (ecx < 4)
                     mov     al, byte ptr Val[ecx]
                  .if al == 0ffh
                        mov     byte ptr Val[ecx], 0feh
                  .endif
                     inc     ecx
               .endw
                  mov     esi, Val
               INVOKE     GetSysColor, COLOR_CAPTIONTEXT
               INVOKE     SetTextColor, dis.hdc, eax
            .else
                  add     esi, 00010101h
               .if sdword ptr esi < 0
                     mov     esi, 00ffffffh   
               .endif
            .endif
               add     edi, ebx
            .if edi < dis.rcItem.right
                  jmp     DoAgain
            .endif
            INVOKE     SetBkMode, dis.hdc, TRANSPARENT
               add     dis.rcItem.left, 3
            INVOKE     DrawText, dis.hdc, addr szBuff1, -1, addr dis.rcItem, DT_SINGLELINE or DT_VCENTER
               sub     dis.rcItem.left, 3
               dec     dis.rcItem.left
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_TOPLEFT
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_BOTTOMRIGHT
               mov     dis.itemState, ODS_DEFAULT
               mov     dis.hdc, 0

         .elseif eax == hHeader
               mov     eax, Color.ColumnBC
            INVOKE     SetBkColor, dis.hdc, eax
               mov     eax, Color.ColumnTC
            INVOKE     SetTextColor, dis.hdc, eax
            INVOKE     SelectObject, dis.hdc, hFontC
              push     eax
            INVOKE     ExtTextOut, dis.hdc, 0, 0, ETO_OPAQUE, addr dis.rcItem, NULL, 0, NULL
               add     dis.rcItem.top, 2
            INVOKE     DrawText, dis.hdc, addr szTree, -1, addr dis.rcItem, DT_CENTER
               sub     dis.rcItem.top, 2
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_TOPLEFT
            INVOKE     DrawEdge, dis.hdc, addr dis.rcItem, BDR_RAISEDOUTER, BF_BOTTOMRIGHT
               pop     eax
            INVOKE     SelectObject, dis.hdc, eax

         .elseif eax == hSMenu || eax == hSubMenu
               mov     szBuff, 0
               mov     eax, dis.itemState
               and     eax, 0fh

            .if eax == ODS_SELECTED
               INVOKE     GetSysColor, COLOR_HIGHLIGHT
                 push     eax
               INVOKE     CreateSolidBrush, eax
                  mov     hBRM, eax
                  dec     dis.rcItem.bottom
               INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
                  inc     dis.rcItem.bottom
               INVOKE     GetSysColor, COLOR_HIGHLIGHTTEXT
               INVOKE     SetTextColor, dis.hdc, eax
                  pop     eax
               INVOKE     SetBkColor, dis.hdc, eax

            .else
               INVOKE     GetSysColor, COLOR_BTNFACE
                 push     eax
               INVOKE     CreateSolidBrush, eax
                  mov     hBRM, eax
               INVOKE     FillRect, dis.hdc, addr dis.rcItem, eax
               INVOKE     GetSysColor, COLOR_BTNTEXT
               INVOKE     SetTextColor, dis.hdc, eax
                  pop     eax
               INVOKE     SetBkColor, dis.hdc, eax
            .endif
            INVOKE     SelectObject, dis.hdc, hFontM
              push     eax

               mov     eax, ImageID
            .if dis.itemID == eax
               INVOKE     CreateCompatibleDC, dis.hdc
                  mov     TempDC, eax
               INVOKE     SelectObject, TempDC, hBitmap
                  mov     htbmp, eax
                  mov     ecx, dis.rcItem.right
                  shr     ecx, 1
                  mov     edx, pWidth
                  shr     edx, 1
                  sub     ecx, edx
                  mov     edx, dis.rcItem.top
                  add     edx, 2
                  mov     rect.left, ecx
                  mov     rect.top, edx
                  add     ecx, pWidth
                  mov     rect.right, ecx
                  add     edx, pHeight
                  mov     rect.bottom, edx
               INVOKE     BitBlt, dis.hdc, rect.left, rect.top, pWidth, pHeight, TempDC, 0, 0, SRCCOPY
                  sub     rect.left, 1
                  sub     rect.top, 1
                  add     rect.right, 1
                  add     rect.bottom, 1
               INVOKE     DrawEdge, dis.hdc, addr rect, BDR_SUNKENOUTER , BF_TOPLEFT
               INVOKE     DrawEdge, dis.hdc, addr rect, BDR_SUNKENOUTER , BF_BOTTOMRIGHT
               INVOKE     SelectObject, TempDC, htbmp
               INVOKE     DeleteDC, TempDC
            .endif

            .if dis.itemID > 6001 && dis.itemID < 6010
                  mov     ecx, dis.itemID
                  sub     ecx, 6002
                  lea     esi, PgmTextArray
               INVOKE     lstrcpy, addr szBuff, [esi+ecx*4]
            .endif

            .if dis.itemID == 6001
               INVOKE     SelectObject, dis.hdc, hFontL
               INVOKE     lstrcpy, addr szBuff, addr szEdit
                  mov     dis.rcItem.left, 16
                  mov     dis.rcItem.right, 200

            .elseif dis.itemID > 6001 && dis.itemID < 6010
               INVOKE     SelectObject, dis.hdc, hFontM
                  mov     dis.rcItem.left, 18
                  mov     dis.rcItem.right, 200
               INVOKE     lstrcpy, addr szRegPath, addr szApplication
               INVOKE     lstrcat, addr szRegPath, addr szBuff
               INVOKE     lstrcat, addr szRegPath, addr szRegSOC
                  mov     lpcbData, sizeof szRegValue
               INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szRegPath, addr szRegValue, addr lpcbData
               .if eax != ERROR_SUCCESS
                  INVOKE     lstrcpy, addr szRegPath, addr szApplication
                  INVOKE     lstrcat, addr szRegPath, addr szBuff
                  INVOKE     lstrcat, addr szRegPath, addr szRegSEC
                     mov     lpcbData, sizeof szRegValue
                  INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szRegPath, addr szRegValue, addr lpcbData
                  .if eax != ERROR_SUCCESS
                        jmp     Pass1
                  .endif
               .endif

               INVOKE     lstrlen, addr szRegValue
                  mov     ebx, eax
                  sub     eax, 2
               .if byte ptr szRegValue[eax] == '%'
                     sub     ebx, 2
               .elseif byte ptr szRegValue[eax-1] == '%'
                     sub     ebx, 4
               .endif
               INVOKE     lstrcpyn, addr szRegValue, addr szRegValue, ebx
               .if byte ptr szRegValue == '"'
                  INVOKE     lstrcpy, addr szRegValue, addr szRegValue+1
                  INVOKE     lstrlen, addr szRegValue
                  INVOKE     lstrcpyn, addr szRegValue, addr szRegValue, eax
               .endif
               INVOKE     lstrlen, addr szRegValue
               .while (eax)
                  .if byte ptr szRegValue[eax-4] == '.'
                        inc     eax
                     .break
                  .endif
                     dec     eax
               .endw
               INVOKE     lstrcpyn, addr szRegValue, addr szRegValue, eax
               .if byte ptr szRegValue+1 == 'u' && byte ptr szRegValue+8 == '.'
                  INVOKE     lstrcpy, addr szRegValue, addr szRegValue+13
;INVOKE     MessageBox, NULL, addr szRegValue, addr AppName, MB_OK
               .endif
               INVOKE     RegOpenKeyEx, HKEY_CURRENT_USER, addr szPgmName, 0, KEY_READ, addr hReg
                  mov     lpcbData, sizeof szBuff
               INVOKE     RegQueryValueEx, hReg, addr szRegValue, 0, addr szREGSZ, addr szBuff, addr lpcbData
               INVOKE     RegCloseKey, hReg

               INVOKE     SHGetFileInfo, addr szRegValue, 0, addr sfi, sizeof SHFILEINFO,\
                          SHGFI_SYSICONINDEX or SHGFI_SMALLICON
                  mov     ecx, eax
               INVOKE     ImageList_Draw, ecx, sfi.iIcon, dis.hdc, 0, dis.rcItem.top,\
                          ILD_NORMAL or ILD_TRANSPARENT
            .endif
            INVOKE     DrawText, dis.hdc, addr szBuff, -1, addr dis.rcItem,\
                       DT_LEFT or DT_VCENTER or DT_SINGLELINE

Pass1:
               pop     eax
            INVOKE     SelectObject, dis.hdc, eax
            INVOKE     DeleteObject, hBRM
               mov     dis.itemState, ODS_DEFAULT
               mov     dis.hdc, 0
         .endif

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
            mov     ecx, wParam
            shr     ecx, 16

;---------- [File
         .if eax == IDM_ATTRI
            INVOKE     CreateDialogParam, hInst, IDD_ATTRI, hWnd, offset AttributesDlg, 0
               jmp     Ret0

         .elseif eax == IDM_ASSOC
            INVOKE     CreateDialogParam, hInst, IDD_ASSOC, hWnd, offset AssociationDlg, 0
               jmp     Ret0

         .elseif eax == IDM_VOLUME
            INVOKE     CreateDialogParam, hInst, IDD_VOLUME, hWnd, offset VolumeDlg, 0

         .elseif eax == IDM_PACK
            INVOKE     PackUnpack, wMsg, wParam, lParam

         .elseif eax == IDM_UNPACK

         .elseif eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

;---------- [Edit
         .elseif eax == IDM_SELECT
               mov     esi, ActiveList
            INVOKE     SendMessage, hWndListL[esi*4], CM_SETSELECTALL, 0, 0

         .elseif eax == IDM_UNSELECT
               mov     esi, ActiveList
            INVOKE     SendMessage, hWndListL[esi*4], CM_CLEARSELECT, 0, 0

         .elseif eax == IDM_INVERT
               mov     esi, ActiveList
            INVOKE     SendMessage, hWndListL[esi*4], CM_INVERTSELECT, 0, 0

;---------- [Options
         .elseif eax == IDM_CONFIG
            INVOKE     CreateDialogParam, hInst, IDD_TABCTL, hWnd, offset TabCtlDlg, 0

;---------- [Help
         .elseif eax == IDM_HELP

         .elseif eax == IDM_ABOUT
            INVOKE     DialogBoxParam, hInst, IDD_ABOUT, hWnd, offset AbVerDlg, 0

;---------- [Function toolbar
;         .elseif eax == IDM_COPYMOVE
;DSPValue hWnd, eax, 1, 't'

         .elseif eax == IDM_COPY
INVOKE     GetAsyncKeyState, VK_CONTROL
   and     eax, 0ffffh
;DSPValue hWnd, eax, 1, 'm'
.if eax <= 1
   mov     Funct, IDM_COPY
INVOKE     lstrcpy, addr szWork, addr szCopyD
.else
   mov     Funct, IDM_MOVE
INVOKE     lstrcpy, addr szWork, addr szMoveD
.endif
              call     DoFileOperation

         .elseif eax == IDM_MOVE
               mov     Funct, eax
            INVOKE     lstrcpy, addr szWork, addr szMoveD
              call     DoFileOperation

         .elseif eax == IDM_RENAME
               mov     Funct, eax
            INVOKE     lstrcpy, addr szWork, addr szRenameD
              call     DoFileOperation

         .elseif eax == IDM_DELETE
               mov     Funct, eax
              call     DoFileOperation
            .if FolderOn
                 call     TreeBranch
            .endif

         .elseif eax == IDM_MAKEDIR
               mov     Funct, eax
            INVOKE     lstrcpy, addr szWork, addr szCreateD
            INVOKE     DialogBoxParam, hInst, IDD_CONFIRM, hWnd, offset ConfirmDlg, 0
            .if szRootPath
                  mov     esi, ActiveList
               INVOKE     SendMessage, hWndListL[esi*4], CM_GETSCROLLPOS, 0, 0
                 push     eax
               INVOKE     CreateDirectory, addr szRootPath, NULL
                  pop     eax
                  xor     ebx, ebx     
               .if eax
                     mov     ebx, hWnd
               .endif
               INVOKE     LockWindowUpdate, ebx
                 call     Refresh
               INVOKE     LockWindowUpdate, 0
               INVOKE     SendMessage, hWndListL[esi*4], CM_SETSCROLLPOS, 0, 0
               INVOKE     SetFocus, hWndListL[esi*4]
            .endif
              call     TreeBranch
               and     Funct, 0

         .elseif eax == IDM_FIND
            INVOKE     CreateDialogParam, hInst, IDD_FIND, hWnd, offset FindDlg, 0

;---------- [Notepad, Paint, control panel, etc
         .elseif eax > 709 && eax < 715
            .if eax == 710
               .if !szWordPath
                     mov     byte ptr szRoot, 'C'
                  INVOKE     SearchTreeForFile, addr szRoot, addr szWordpad, addr szWordPath
               .endif
               INVOKE     RtlZeroMemory, addr stin, sizeof stin
               INVOKE     CreateProcess, 0, addr szWordPath, 0, 0, FALSE,\
                          NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
               INVOKE     CloseHandle, prin.hProcess
               INVOKE     CloseHandle, prin.hThread

            .elseif eax == 711
               INVOKE     RtlZeroMemory, addr stin, sizeof stin
               INVOKE     CreateProcess, 0, addr szNotepad, 0, 0, FALSE,\
                          NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
               INVOKE     CloseHandle, prin.hProcess
               INVOKE     CloseHandle, prin.hThread

            .elseif eax == 712
               INVOKE     RtlZeroMemory, addr stin, sizeof stin
               INVOKE     CreateProcess, 0, addr szPaint, 0, 0, FALSE,\
                          NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
               .if !eax
                  INVOKE     CreateProcess, 0, addr szPaintXP, 0, 0, FALSE,\
                             NORMAL_PRIORITY_CLASS, 0, 0 , addr stin, addr prin
               .endif
               INVOKE     CloseHandle, prin.hProcess
               INVOKE     CloseHandle, prin.hThread

            .elseif eax == 713
               INVOKE     WinExec, addr szControl, SW_SHOWNORMAL     ; Exec a program

            .elseif eax == 714
               INVOKE     ShellExecute, hWnd, NULL, addr szDesktop, NULL, NULL, SW_SHOWNORMAL
;               INVOKE     RtlZeroMemory, addr sei, sizeof sei
;                  mov     sei.cbSize, sizeof SHELLEXECUTEINFO
;                  mov     sei.fMask, 0
;                  mov     eax, hWnd
;                  mov     sei.hwnd, eax
;                  lea     eax, szDesktop
;                  mov     sei.lpFile, eax
;                  mov     sei.nShow, SW_SHOWNORMAL
;               INVOKE     ShellExecuteEx, addr sei
            .endif

;---------- [Drive toolbar

         .elseif eax > 999 && eax < 1026         ; Drive toolbar
               sub     eax, 1000
               mov     edi, eax
               mov     cl, byte ptr DriveArrayL[eax]
               mov     byte ptr szDrv, cl
               mov     byte ptr szDrv+1, 0
               and     FileOper, 0
            INVOKE     lstrcat, addr szDrv, addr szColon
            INVOKE     lstrcat, addr szDrv, addr szSlashB
            INVOKE     lstrcpy, addr szPath, addr szDrv
               sub     szPath, 20h
               mov     ebx, ActiveList
               mov     edi, hPathL[ebx*4]
               xor     eax, eax

            .if !ActiveList
                  mov     al, byte ptr szPath
               .if al != byte ptr szListPathL
                     mov     CollaspeOn, 1
               .endif
                  sub     al, 'A'
                 imul     eax, sizeof HPATH
                  add     edi, eax
               INVOKE     lstrcpy, addr szListPathL, addr [edi].HPATH.szPath
                  mov     al, byte ptr szListPathL
               .if byte ptr szListPathL+3 == 0 && al == byte ptr szListPathR
                  INVOKE     lstrcpy, addr szListPathL, addr szListPathR
               .endif

            .else
                  mov     al, byte ptr szPath
               .if al != byte ptr szListPathR
                     mov     CollaspeOn, 1
               .endif
                  sub     al, 'A'
                 imul     eax, sizeof HPATH
                  add     edi, eax
               INVOKE     lstrcpy, addr szListPathR, addr [edi].HPATH.szPath
                  mov     al, byte ptr szListPathR
               .if byte ptr szListPathR+3 == 0 && al == byte ptr szListPathL
                  INVOKE     lstrcpy, addr szListPathR, addr szListPathL
               .endif
            .endif
               mov     ebx, ActiveList
            INVOKE     SendMessage, hWndListL[ebx*4], CM_CLEAREDIT, 0, 0
              call     Refresh
            .if eax == -1
                  jmp     Ret0
            .endif
              call     TreeBranch

;---------- [Combo drive selection
         .elseif ecx == CBN_SELCHANGE && eax == 42 || ecx == CBN_SELCHANGE && eax == 43
               mov     edx, lParam
            .if edx != hComboL && edx != hComboR
                  jmp     Ret0
            .endif
               sub     eax, 42            ; ID of hComboL
            .if eax != ActiveList
                  mov     ActiveList, eax
               .if ActiveList == 0
                  INVOKE     SendMessage, hWndListL, CM_SETACTIVE, 0, 1
                  INVOKE     SendMessage, hWndListR, CM_SETACTIVE, 0, 0
               .else
                  INVOKE     SendMessage, hWndListL, CM_SETACTIVE, 0, 0
                  INVOKE     SendMessage, hWndListR, CM_SETACTIVE, 0, 1
               .endif
               INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0
            .endif
               mov     ebx, ActiveList
            INVOKE     SendMessage, hWndListL[ebx*4], CM_CLEAREDIT, 0, 0
            INVOKE     SendMessage, hComboL[ebx*4], CB_GETCURSEL, 0, 0
            .if eax == CB_ERR
                  jmp     Ret0
            .endif
               mov     ecx, eax
            INVOKE     SendMessage, hComboL[ebx*4], CB_GETLBTEXT, ecx, addr szBuff
               mov     al, byte ptr szBuff+2
               mov     byte ptr szDrv, al
               mov     byte ptr szDrv+1, 0
               and     FileOper, 0
            INVOKE     lstrcat, addr szDrv, addr szColon
            INVOKE     lstrcat, addr szDrv, addr szSlashB
            INVOKE     lstrcpy, addr szPath, addr szDrv
               sub     szPath, 20h
               mov     ebx, ActiveList
               mov     edi, hPathL[ebx*4]
               xor     eax, eax

            .if !ActiveList
                  mov     al, byte ptr szPath
                  sub     al, 'A'
                 imul     eax, sizeof HPATH
                  add     edi, eax
               INVOKE     lstrcpy,addr szListPathL, addr [edi].HPATH.szPath
                  mov     al, byte ptr szListPathL
               .if byte ptr szListPathL+3 == 0 && al == byte ptr szListPathR
                  INVOKE     lstrcpy, addr szListPathL, addr szListPathR
               .endif

            .else
                  mov     al, byte ptr szPath
                  sub     al, 'A'
                 imul     eax, sizeof HPATH
                  add     edi, eax
               INVOKE     lstrcpy,addr szListPathR, addr [edi].HPATH.szPath
                  mov     al, byte ptr szListPathR
               .if byte ptr szListPathR+3 == 0 && al == byte ptr szListPathL
                  INVOKE     lstrcpy, addr szListPathR, addr szListPathL
               .endif
            .endif
              call     Refresh
            .if eax == -1
               .if !ActiveList
                     mov     al, byte ptr szListPathL
               .else
                     mov     al, byte ptr szListPathR
               .endif
               .if al < 61h
                     add     al, 20h
               .endif
                  mov     byte ptr szCombo+2, al
                  mov     ebx, ActiveList
               INVOKE     SendMessage, hComboL[ebx*4], CB_FINDSTRINGEXACT, -1, addr szCombo
                  mov     edi, eax
               INVOKE     SendMessage, hComboL[ebx*4], CB_SETCURSEL, edi, 0
                  jmp     Ret0
            .endif
              call     TreeBranch

         .elseif eax == 2000             ; Left refresh button
               and     FileOper, 0
              push     ActiveList
               mov     ActiveList, 0
               mov     ebx, 0
            INVOKE     SendMessage, hWndListL, CM_GETSCROLLPOS, 0, 0
            .if eax
                  mov     ebx, hWnd
            .endif
            INVOKE     LockWindowUpdate, ebx
              call     Refresh
            INVOKE     LockWindowUpdate, 0
            INVOKE     SendMessage, hWndListL, CM_SETSCROLLPOS, 0, 0
            INVOKE     SetFocus, hWndListL
               pop     eax
            .if eax != ActiveList
                 call     TreeBranch
            .endif
            INVOKE     lstrcpy, addr szBuff1, addr szRootPath
            INVOKE     lstrcpy, addr szRootPath, addr szPastePath
              call     RemFileName
            INVOKE     lstrcmpi, addr szRootPath, addr szListPathL
            .if !eax
                  mov     szPastePath, 0
            .endif
            INVOKE     lstrcpy, addr szRootPath, addr szBuff1
            INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0

         .elseif eax == 2001             ; Right refresh button
               and     FileOper, 0
              push     ActiveList
               mov     ActiveList, 1
               mov     ebx, 0
            INVOKE     SendMessage, hWndListR, CM_GETSCROLLPOS, 0, 0
            .if eax
                  mov     ebx, hWnd
            .endif
            INVOKE     LockWindowUpdate, ebx
              call     Refresh
            INVOKE     LockWindowUpdate, 0
            INVOKE     SendMessage, hWndListR, CM_SETSCROLLPOS, 0, 0
            INVOKE     SetFocus, hWndListR
               pop     eax
            .if eax != ActiveList
                 call     TreeBranch
            .endif
            INVOKE     lstrcpy, addr szBuff1, addr szRootPath
            INVOKE     lstrcpy, addr szRootPath, addr szPastePath
              call     RemFileName
            INVOKE     lstrcmpi, addr szRootPath, addr szListPathR
            .if !eax
                  mov     szPastePath, 0
            .endif
            INVOKE     lstrcpy, addr szRootPath, addr szBuff1
            INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0

         .elseif eax == 2010             ; Left selection bar
               and     FileOper, 0
            .if ActiveList == 0
                  jmp     Ret0
            .endif
               mov     ActiveList, 0
              call     ChkButt

         .elseif eax == 2011             ; Right selection bar
               and     FileOper, 0
            .if ActiveList == 1
                  jmp     Ret0
            .endif
               mov     ActiveList, 1
              call     ChkButt

         .elseif eax == 6098
              call     DoShortcut

;         .elseif eax == 6099
;              call     DoProperties

         .elseif eax == IDM_TEST

         .elseif eax == IDM_EXPLODE
               mov     Funct, eax
              call     DoFileOperation

         .elseif eax == IDM_TAB
               mov     nmhdr.code, eax
            .if !ActiveList
                  mov     eax, hWndListR
            .else
                  mov     eax, hWndListL
            .endif
               mov     nmhdr.hwndFrom, eax
               lea     eax, nmhdr
            INVOKE     SendMessage, hWnd, WM_NOTIFY, 0, eax
         .endif

      .elseif wMsg == WM_MOUSEMOVE && !DragFrTree && !DragOn
         INVOKE     ChkSplitter, wParam, lParam

      .elseif wMsg == WM_MOUSEMOVE && DragFrTree
            mov     eax, lParam
            and     eax, 0ffffh
            mov     ecx, lParam
            shr     ecx, 16
            mov     tvht.pt.x, eax
            sub     ecx, 106  ; Top of Treeview
            mov     tvht.pt.y, ecx
.if eax > SplitV[4]
         .if DragMode
            INVOKE     SendMessage, hWndListL, CM_SETTREEMODE, 0, 1
               and     DragMode, 0
;INVOKE     MessageBox, NULL, addr szRootPath, addr AppName, MB_OK
         .endif
         INVOKE     ImageList_DragLeave, hWndTree
         INVOKE     ImageList_EndDrag
         INVOKE     ImageList_Destroy, hDragImageList
;         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_DROPHILITE, 0
;         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, DragFrTree ;eax
         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_DROPHILITE, 0
         INVOKE     ReleaseCapture
;;            and     DragFrTree, 0
.endif

         INVOKE     ImageList_DragMove, eax, ecx
         INVOKE     ImageList_DragShowNolock, FALSE
         INVOKE     SendMessage, hWndTree, TVM_HITTEST, NULL, addr tvht
         .if eax
;            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_DROPHILITE, eax
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, tvht.hItem
         .endif
         INVOKE     ImageList_DragShowNolock, TRUE

      .elseif wMsg == WM_MOUSEMOVE && wParam == MK_LBUTTON && DragOn && TreeviewOn
            mov     eax, lParam
            and     eax, 0ffffh
            mov     tvht.pt.x, eax
            mov     ecx, SplitV[4]
            add     ecx, 2
         .if sdword ptr eax > 1
               sub     eax, 2
         .else
               mov     eax, 0
         .endif
;DSPValue hWnd, tvht.pt.x, 1, 't'
;DSPValue hWndStat, ecx, 1, 's'
;DSPValue hWndStat, tvht.pt.x, 1, 's'
         .if sdword ptr eax <= ecx
               mov     eax, lParam
               shr     eax, 16
               sub     eax, 106  ; Top of Treeview
               mov     tvht.pt.y, eax
            INVOKE     SendMessage, hWndTree, TVM_HITTEST, 0, addr tvht
            .if tvht.flags == TVHT_ONITEMICON || tvht.flags == TVHT_ONITEMLABEL
               INVOKE     SetCursor, hDrop
               INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, tvht.hItem
            .else
               .if tvht.pt.x < 10
                  INVOKE     LoadCursor, 0, IDC_ARROW
                  INVOKE     SetCursor, eax
               .else
                  INVOKE     SetCursor, hDrag
               .endif
            .endif
         .elseif sdword ptr eax < 10000
            INVOKE     ReleaseCapture
         .endif

      .elseif wMsg == WM_LBUTTONUP && DragFrTree
INVOKE     ReleaseCapture
         INVOKE     ImageList_DragLeave, hWndTree
         INVOKE     ImageList_EndDrag
         INVOKE     ImageList_Destroy, hDragImageList
;         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_DROPHILITE, 0
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CARET, 0
            mov     ebx, eax
         .if ebx == hItemT
               jmp     BothSame
         .endif
            mov     ecx, hWndTree
            mov     nmtree.hdr.hwndFrom, ecx
            mov     nmtree.hdr.code, TVN_SELCHANGING
            mov     eax, hItemT
            mov     nmtree.itemNew.hItem, eax
            mov     nmtree.itemNew.state, 0
            mov     nmtree.itemOld.state, 0
            mov     nmtree.action, TVIS_FOCUSED
            lea     eax, nmtree
            and     DragFrTree, 0
            mov     DragInTree, 1
         INVOKE     SendMessage, hWnd, WM_NOTIFY, 0, eax
         INVOKE     lstrcpy, addr szBuffFr, addr szRootPath
            mov     nmtree.itemNew.hItem, ebx
            lea     eax, nmtree
         INVOKE     SendMessage, hWnd, WM_NOTIFY, 0, eax
         INVOKE     lstrcpy, addr szBuffTo, addr szRootPath
INVOKE     GetAsyncKeyState, VK_CONTROL
;DSPValue hWnd, eax, 1, 't'
.if !eax
   mov     Funct, IDM_COPY
INVOKE     lstrcpy, addr szWork, addr szCopyD
.else
   mov     Funct, IDM_MOVE
INVOKE     lstrcpy, addr szWork, addr szMoveD
.endif
           call     DoFileOperation

BothSame:
         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, DragFrTree
         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_DROPHILITE, 0
         .if !ActiveList
               mov     eax, hItemL
         .else
               mov     eax, hItemR
         .endif
         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, eax
;         INVOKE     ReleaseCapture
            and     DragFrTree, 0
            and     DragInTree, 0

      .elseif wMsg == WM_LBUTTONUP
INVOKE     ReleaseCapture
         INVOKE     GetCursor
         .if eax == hDrop
              push     hItem
INVOKE     GetAsyncKeyState, VK_CONTROL
;DSPValue hWnd, eax, 1, 't'
.if !eax
   mov     Funct, IDM_COPY
INVOKE     lstrcpy, addr szWork, addr szCopyD
.else
   mov     Funct, IDM_MOVE
INVOKE     lstrcpy, addr szWork, addr szMoveD
.endif
               mov     DragToTree, 1
               mov     eax, hWndTree
               mov     nmtree.hdr.hwndFrom, eax
               mov     nmtree.hdr.code, TVN_SELCHANGING
               mov     eax, tvht.hItem ;SavItem
               mov     nmtree.itemNew.hItem, eax
               mov     nmtree.itemNew.state, 0
               mov     nmtree.itemOld.state, 0
               mov     nmtree.action, TVIS_FOCUSED
               lea     eax, nmtree
            INVOKE     SendMessage, hWnd, WM_NOTIFY, 0, eax
              call     DoFileOperation
;               lea     eax, nmtree
;            INVOKE     SendMessage, hWnd, WM_NOTIFY, 0, eax
               pop     hItem
            .if !ActiveList
                  mov     eax, hItemL
            .else
                  mov     eax, hItemR
            .endif
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, eax ;hItem
;              call     TreeBranch
               and     DragToTree, 0
         .endif

;---------- [Restore the cursor and call WM_SIZE] ----------
;         INVOKE     ReleaseCapture
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
            and     DragOn, 0
         .if hSplitBar
            INVOKE     SplitBarProc, hSplitBar, WM_COMMAND, IDCANCEL, 0
               and     hSplitBar, 0
            INVOKE     GetClientRect, hWnd, addr rect
               mov     edx, rect.bottom
               shl     edx, 16
               mov     ecx, rect.right
               mov     dx, cx
            INVOKE     SendMessage, hWnd, WM_SIZE, 0, edx
            INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0
            INVOKE     SendMessage, hWndListL, CM_REDRAW, 0, 0
            INVOKE     SendMessage, hWndListR, CM_REDRAW, 0, 0
         .endif
            and     BarType, 0

      .elseif wMsg == WM_CLOSE
         .if ipPicture
               mov     eax, ipPicture
              push     eax
               mov     edx, dword ptr[eax]
              call     dword ptr[edx+8]          ; ipPicture->Release()
            INVOKE     DeleteObject, hBitmap
         .endif

         .if hSHNotify && lpSHChangeNotifyUnregister
            INVOKE     lpSHChangeNotifyUnregister, hSHNotify
         .endif

           call     RegSave
         INVOKE     HeapFree, hDefHeap, 0, hBuff
         INVOKE     HeapFree, hDefHeap, 0, hPathL
         INVOKE     HeapFree, hDefHeap, 0, hPathR
         INVOKE     ImageList_Destroy, hImageListD
         INVOKE     ImageList_Destroy, hImageListN
         INVOKE     ImageList_Destroy, hImageListT
         INVOKE     ImageList_Destroy, hImageListL
         INVOKE     ImageList_Destroy, hImageListR
         INVOKE     ImageList_Destroy, hSingleImage
         INVOKE     ImageList_Destroy, hImageListTree
         INVOKE     DeleteObject, hFontC
         INVOKE     DeleteObject, hFontL
         INVOKE     DeleteObject, hFontM
         INVOKE     DeleteObject, hFontS
         INVOKE     DeleteObject, hFontT
         INVOKE     DestroyCursor, hSplit
         INVOKE     DestroyCursor, hDrag
         INVOKE     DestroyCursor, hDrop
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif
         jmp     Ret0

NoSelection:
      INVOKE     MessageBox, NULL, addr szNoSelect, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL

Ret0:
         xor    eax, eax
         ret

Ret1:
         mov    eax, 1
         ret

ChkButt:
;---------- [Check for removable drive and if it is loaded
      .if !ActiveList
         INVOKE     lstrcpy, addr szRootPath, addr szListPathL
      .else
         INVOKE     lstrcpy, addr szRootPath, addr szListPathR
      .endif
         mov     al, byte ptr szPath
         mov     byte ptr szDrv, al
      INVOKE     GetDriveType, addr szDrv
      .if eax == DRIVE_REMOVABLE || eax == DRIVE_CDROM
         INVOKE     lstrcat, addr szRootPath, addr szDummy+3
         INVOKE     PathToPidl, 1
         .if eax == -1
            .if !ActiveList
               INVOKE     lstrcpyn, addr szDrv, addr szListPathR, 4
               INVOKE     lstrcpy, addr szListPathL, addr szListPathR
            .else
               INVOKE     lstrcpyn, addr szDrv, addr szListPathL, 4
               INVOKE     lstrcpy, addr szListPathR, addr szListPathL
            .endif
              call     Refresh
         .endif
      .endif
;----------

      .if !ActiveList
         INVOKE     SendMessage, hWndListR, CM_CLEAREDIT, 0, 0
         INVOKE     SendMessage, hWndListR, CM_SETACTIVE, 0, 0
         INVOKE     SendMessage, hWndListL, CM_SETACTIVE, 0, 1
         INVOKE     SendMessage, hWndDrives, TB_ISBUTTONCHECKED, SavButtL, 0
         .if !eax
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtR, FALSE
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtL, TRUE
         .endif

      .else
         INVOKE     SendMessage, hWndListL, CM_CLEAREDIT, 0, 0
         INVOKE     SendMessage, hWndListL, CM_SETACTIVE, 0, 0
         INVOKE     SendMessage, hWndListR, CM_SETACTIVE, 0, 1
         INVOKE     SendMessage, hWndDrives, TB_ISBUTTONCHECKED, SavButtR, 0
         .if !eax
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtL, FALSE
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtR, TRUE
         .endif
      .endif
      INVOKE     lstrcmpi, addr szListPathL, addr szListPathR
      .if eax
           call     TreeBranch
      .endif
      INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0

         mov     eax, ActiveList
      INVOKE     SetFocus, hWndListL[eax*4]

        retn

WndProc ENDP

;===================================================
; Initialization PROCEDURE
;===================================================
Initialize PROC uses esi edi
LOCAL    hReg:DWORD, FirstFlg
LOCAL    szBuffer[1024]:BYTE

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hReg, addr lpdwDisp
         mov     lpcbData, sizeof szListPathL
      INVOKE     RegQueryValueEx, hReg, addr ListPathL, 0, addr lpType, addr szListPathL, addr lpcbData
         mov     lpcbData, sizeof szListPathR
      INVOKE     RegQueryValueEx, hReg, addr ListPathR, 0, addr lpType, addr szListPathR, addr lpcbData

         mov     lpcbData, sizeof szZipPack
      INVOKE     RegQueryValueEx, hReg, addr ZipPack, 0, addr lpType, addr szZipPack, addr lpcbData
         mov     lpcbData, sizeof szZipUnPack
      INVOKE     RegQueryValueEx, hReg, addr ZipUnPack, 0, addr lpType, addr szZipUnPack, addr lpcbData
         mov     lpcbData, sizeof szPgmZip
      INVOKE     RegQueryValueEx, hReg, addr PgmZip, 0, addr lpType, addr szPgmZip, addr lpcbData
         mov     lpcbData, sizeof szEditPgr
      INVOKE     RegQueryValueEx, hReg, addr EditPgr, 0, addr lpType, addr szEditPgr, addr lpcbData
         mov     lpcbData, sizeof szWordPath
      INVOKE     RegQueryValueEx, hReg, addr WordPath, 0, addr lpType, addr szWordPath, addr lpcbData

      INVOKE     RegQuery, addr szActive, addr ActiveList
      INVOKE     RegQuery, addr szShowGrid, addr ShowGrid
      INVOKE     RegQuery, addr szShowHidden, addr ShowHidden
      INVOKE     RegQuery, addr szShowConfC, addr ShowConfC
      INVOKE     RegQuery, addr szShowConfD, addr ShowConfD
      INVOKE     RegQuery, addr szShowProgess, addr ShowProgess
      INVOKE     RegQuery, addr szShowProcess, addr ShowProcessed
      INVOKE     RegQuery, addr szSaveOnExit, addr SaveOnExit
      INVOKE     RegQuery, addr szCopyToRecyc, addr CopyToRecycle
      INVOKE     RegQuery, addr szViewFlag, addr ViewFlag
      INVOKE     RegQuery, addr szChkZip, addr ChkZip
      INVOKE     RegQuery, addr szEqualOn, addr EqualOn

         mov     lpcbData, sizeof SortL
      INVOKE     RegQuerySZ, addr szSortL, addr SortL
         mov     lpcbData, sizeof SortR
      INVOKE     RegQuerySZ, addr szSortR, addr SortR

         mov     lpcbData, sizeof SplitV
      INVOKE     RegQuerySZ, addr szSplitV, addr SplitV

         mov     lpcbData, sizeof ColWth
      INVOKE     RegQuerySZ, addr szColWth, addr ColWth

         mov     lpcbData, sizeof Color
      INVOKE     RegQuerySZ, addr szFileManClrs, addr Color.SelBarF

         mov     lpcbData, sizeof CustClrs
      INVOKE     RegQuerySZ, addr szCustClrs, addr CustClrs
      .if dword ptr CustClrs == 0 && dword ptr CustClrs[4] == 0
            lea     esi, DefCustColor
            lea     edi, CustClrs
            mov     ecx, 16
         .while (ecx)
               mov     eax, [esi]
               mov     [edi], eax
               add     esi, 4
               add     edi, 4
               dec     ecx
         .endw
      .endif
      INVOKE     RegCloseKey, hReg

         ret

Initialize ENDP

;===============================================================
; Create the Custom Listbox Control
;===============================================================
CreateList PROC uses ebx esi edi

         mov     ebx, ActiveList
         mov     ecx, 2001
         add     ecx, ebx
      INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr CListClass, NULL,\
                 WS_CHILD or WS_VISIBLE or WS_VSCROLL or WS_HSCROLL or \
                 WS_TABSTOP or LBS_NOTIFY or LBS_NOREDRAW or LBS_MULTIPLESEL,\
                 0, 0, 0, 0, hWnd, ecx, hInst, NULL ;0, 0, 442, 246
         mov     hWndListL[ebx*4], eax

      INVOKE     SendMessage, hWndListL[ebx*4], CM_SETGRIDLINES, ShowGrid, 0
        call     CreateImagelist

         mov     byte ptr szRoot, 'A'
         xor     esi, esi
         mov     edi, hPathL[ebx*4]
      .while (byte ptr szRoot <= 'Z')
         INVOKE     lstrcpy, addr [edi].HPATH.szPath, addr szRoot
            add     szRoot, 1
            add     edi, sizeof HPATH
      .endw
         mov     byte ptr szRoot, 'C'

         mov     edi, hPathL[ebx*4]
         xor     eax, eax
      .if !ActiveList
            mov     al, byte ptr szListPathL
            sub     al, 'A'
           imul     eax, sizeof HPATH
            add     edi, eax
         INVOKE     lstrcpy, addr [edi].HPATH.szPath, addr szListPathL
      .else
            mov     al, byte ptr szListPathR
            sub     al, 'A'
           imul     eax, sizeof HPATH
            add     edi, eax
         INVOKE     lstrcpy, addr [edi].HPATH.szPath, addr szListPathR
      .endif
         ret

CreateList ENDP

;===============================================================
; Add columns
;===============================================================
AddColumns PROC uses ebx esi edi
LOCAL    col:COLUMN
LOCAL    Cnt:DWORD, Num

         mov     ebx, ActiveList
;      INVOKE     LockWindowUpdate, hWndListL[ebx*4]
         lea     esi, ColTextArray
         xor     edi, edi
         mov     Num, 1
       MOVmd     Cnt, NumColumns
      .while (Cnt)
          MOVmd     col.ColWth, ColWth[edi*4]
          MOVmd     col.lpszhdrtext, [esi]
         .if Num == 3 || Num == 6
               mov     col.HeaderAlign, ALIGN_CENTER
               mov     col.ColumnAlign, ALIGN_RIGHT
               mov     col.ColumnType, TYPE_EDITLONG
         .else
               mov     col.HeaderAlign, ALIGN_LEFT
               mov     col.ColumnAlign, ALIGN_LEFT
               mov     col.ColumnType, TYPE_EDITTEXT
         .endif
          MOVmd     col.MaxLen, TextLen01[edi*4]
            mov     col.lpszFormat, 0
         .if Num == 1
             MOVmd     col.lpszPath, ColPathArray[ebx*4]
             MOVmd     col.hImageList, hImageListL[ebx*4]
         .else
               mov     col.lpszPath, 0
               mov     col.hImageList, 0
         .endif
            mov     col.SortFlag, 0
            mov     col.SortAD, 0
          MOVmd     col.ColNum, Num
            dec     col.ColNum
            mov     ecx, SortL[ebx*8]       ; Column num
            mov     edx, SortL[ebx*8+4]     ; Ascending or Descending
            mov     eax, 8
         .if !edx
               mov     eax, 9
         .endif
         .if ecx == col.ColNum
               mov     col.SortAD, eax
         .endif
         INVOKE     SendMessage, hWndListL[ebx*4], CM_ADDCOL, 0, addr col
            inc     edi
            add     esi, 4
            inc     Num
            dec     Cnt
      .endw
;      INVOKE     LockWindowUpdate, 0
         ret

AddColumns ENDP

;===============================================================
; Set column text
;===============================================================
SetColumn PROC uses ebx esi edi
LOCAL    Cnt:DWORD

         mov     ebx, ActiveList
         lea     esi, ColTextArray
         xor     edi, edi
       MOVmd     Cnt, NumColumns
      .while (Cnt)
         INVOKE     SendMessage, hWndListL[ebx*4], CM_SETHDRTEXT, edi, [esi]
            add     esi, 4
            inc     edi
            dec     Cnt
      .endw
         ret

SetColumn ENDP

;===============================================================
; Check toolbar button
;===============================================================
ChkTool PROC

      .if !ActiveList
         INVOKE     SendMessage, hWndDrives, TB_ISBUTTONCHECKED, SavButtL, 0
         .if !eax
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtR, FALSE
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtL, TRUE
         .endif

      .else
         INVOKE     SendMessage, hWndDrives, TB_ISBUTTONCHECKED, SavButtR, 0
         .if !eax
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtL, FALSE
            INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtR, TRUE
         .endif
      .endif

         ret

ChkTool ENDP

;===============================================================
; Set the colors and fonts for the list controls
;===============================================================
SetColorFont PROC

         mov     ebx, ActiveList
      INVOKE     SendMessage, hWndListL[ebx*4], CM_SETCOLORS, 0, addr Color
      INVOKE     SendMessage, hWndListL[ebx*4], CM_SETFONTS, hFontC, hFontL
         ret

SetColorFont ENDP

;===============================================================
; Create the imagelist for the list controls
;===============================================================
CreateImagelist PROC

         mov     ebx, ActiveList
      .if hImageListL[ebx*4]
         INVOKE     ImageList_Destroy, hImageListL[ebx*4]
      .endif
;      INVOKE     ImageList_Create, 16, 16, ILC_MASK, 256, 128
      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16 or ILC_MASK, 4, 4
         mov     hImageListL[ebx*4], eax
      INVOKE     LoadIcon, hInst, 8004
        push     eax
      INVOKE     ImageList_AddIcon, hImageListL[ebx*4], eax
         pop     eax
      INVOKE     DestroyIcon, eax
      INVOKE     LoadIcon, hInst, 8005
        push     eax
      INVOKE     ImageList_AddIcon, hImageListL[ebx*4], eax
         pop     eax
      INVOKE     DestroyIcon, eax
      INVOKE     LoadIcon, hInst, 8006
        push     eax
      INVOKE     ImageList_AddIcon, hImageListL[ebx*4], eax
         pop     eax
      INVOKE     DestroyIcon, eax
         ret

CreateImagelist ENDP

;===============================================================
; Get the image ID for the list controls
;===============================================================
GetImageID PROC uses ebx esi edi
LOCAL    sfi:SHFILEINFO
LOCAL    hDC:DWORD

;      INVOKE     GetDC, hWnd
;         mov     hDC, eax
         lea     esi, ExtArray
         xor     edi, edi
         mov     ebx, 42
      .while (ebx)
            mov     ecx, [esi+edi*4]
         INVOKE     SHGetFileInfo, ecx, FILE_ATTRIBUTE_NORMAL, addr sfi, sizeof SHFILEINFO,\
                    SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_USEFILEATTRIBUTES
            mov     eax, sfi.iIcon
            mov     ImageIDS[edi*4], eax
;         INVOKE     ImageList_Draw, hImageList, sfi.iIcon, hDC, 280, 350, ILD_NORMAL
;DSPValue hWnd, sfi.iIcon, 1, 'm'
mov     ecx, [esi+edi*4]
mov     al, [ecx+1]
.if al == 'p'
;DSPValue hWnd, 1111, 1, 'm'
;DSPValue hWnd, sfi.iIcon, 1, 'm'
.endif
            inc     edi
            dec     ebx
      .endw
;      INVOKE     ReleaseDC, hWnd, hDC
         ret

GetImageID ENDP

;===============================================================
; Refresh listview Procedure
;===============================================================
Refresh PROC uses ebx

      INVOKE     GetDriveType, addr szDrv
      .if eax == DRIVE_REMOVABLE || eax == DRIVE_CDROM
         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
         .endif
         INVOKE     lstrcat, addr szRootPath, addr szDummy+3
         INVOKE     PathToPidl, 1
         .if eax == -1
;            .if !ActiveList
;               INVOKE     SendMessage, hSelBarL, WM_GETTEXT, sizeof szListPathL, addr szListPathL
;               INVOKE     lstrlen, addr szListPathL
;                  sub     eax, 2
;               INVOKE     lstrcpyn, addr szListPathL, addr szListPathL, eax
;            .else
;               INVOKE     SendMessage, hSelBarR, WM_GETTEXT, sizeof szListPathR, addr szListPathR
;               INVOKE     lstrlen, addr szListPathR
;                  sub     eax, 2
;               INVOKE     lstrcpyn, addr szListPathR, addr szListPathR, eax
;            .endif

            .if !ActiveList
               INVOKE     lstrcpy, addr szListPathL, addr szListPathR
            .else
               INVOKE     lstrcpy, addr szListPathR, addr szListPathL
            .endif
         .endif
      .endif

         mov     ebx, ActiveList
INVOKE     SendMessage, hWndListL[ebx*4], WM_SETREDRAW, 0, 0
      INVOKE     SendMessage, hWndListL[ebx*4], CM_RESETCONTENT, 0, 0
        call     SetColumn
        call     LoadFiles
INVOKE     SendMessage, hWndListL[ebx*4], WM_SETREDRAW, 1, 0
INVOKE     RedrawWindow, hWndListL[ebx*4], 0, 0, RDW_INVALIDATE or RDW_UPDATENOW

         ret

Refresh ENDP

;===============================================================
; Load listview files Procedure
;===============================================================
LoadFiles PROC uses ebx esi edi
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    rd:ROWDATA
LOCAL    Lft:FILETIME
LOCAL    sfi:SHFILEINFO
LOCAL    rect:RECT
LOCAL    hFind:DWORD, Row
LOCAL    szBuff0[256]:BYTE, szSize[12]:BYTE, szAttr[12]:BYTE, szBuff1[256]:BYTE

;      INVOKE     StatusBar, 0, 0, 0, 0
         mov     ebx, ActiveList
         and     ListSelS, 0
         and     ListSelN, 0
         and     ListTotS, 0
         and     ListTotN, 0
      .if !ActiveList
         INVOKE     lstrcpy, addr szPath, addr szListPathL
      .else
         INVOKE     lstrcpy, addr szPath, addr szListPathR
      .endif

;---------- [Check for removable drive and if it is loaded
         mov     al, byte ptr szPath
         mov     byte ptr szDriveType, al


      INVOKE     GetDriveType, addr szDriveType
      .if eax == DRIVE_REMOVABLE || eax == DRIVE_CDROM
         INVOKE     lstrcpy, addr szRootPath, addr szPath
         INVOKE     lstrcat, addr szRootPath, addr szDummy+3
         INVOKE     PathToPidl, 1
         .if eax == -1
            .if !ActiveList
               INVOKE     lstrcpy, addr szPath, addr szListPathR
               INVOKE     lstrcpy, addr szListPathL, addr szPath
            .else
               INVOKE     lstrcpy, addr szPath, addr szListPathL
               INVOKE     lstrcpy, addr szListPathR, addr szPath
            .endif
         .endif
      .endif
;----------

      INVOKE     lstrcat, addr szPath, addr szAllFiles
      INVOKE     lstrcpyn, addr szDrv, addr szPath, 4
        call     GetHeader
;INVOKE     MessageBox, NULL, addr szPath, addr AppName, MB_OK
         xor     esi, esi
      INVOKE     FindFirstFile, addr szPath, addr FindData
        push     eax
         mov     hFind, eax
         and     Row, 0
      INVOKE     lstrlen, addr szPath
      .if eax > 6
            lea     eax, szBack
            mov     rd.lpName, eax
            mov     rd.lpExt, 0
            mov     rd.lpSize, 0
            lea     eax, szDateL
            mov     rd.lpDate, eax
         INVOKE     lstrcpy, addr szAttr, addr szFill
            lea     edx, szAttr
            mov     rd.lpAttr, eax
            mov     rd.Index, 1
         INVOKE     SendMessage, hWndListL[ebx*4], CM_ADDROW, 0, addr rd
      .endif
         pop     eax
        test     eax, eax
          js     DoFill
         jmp     AddemLV

GetemLV:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     AllDoneLV

AddemLV:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ||\
          (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) ||\
          (FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)
;            jmp     GetemLV
      .endif
      .if byte ptr FindData.cFileName == '.'
            jmp     GetemLV
      .endif

         mov     rd.Index, 0
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
            mov     rd.Index, 2
      .else
            mov     rd.Index, 3
            add     ListTotN, 1
      .endif
         lea     eax, FindData.cFileName
         mov     rd.lpName, eax

      INVOKE     lstrlen, addr FindData.cFileName
         mov     edi, eax
      .while (eax)
            dec     eax
         .if FindData.cFileName[eax] == '.'
            .break
         .endif
      .endw
      .if !eax
            mov     szExt, 0
            jmp     NoExt
      .endif
         inc     eax
        push     eax
      INVOKE     lstrcpy, addr szExt, addr FindData.cFileName[eax]
         pop     eax
         sub     edi, eax
         mov     ecx, edi

         lea     esi, szExt
         xor     eax, eax
      .while (ecx)
         .if byte ptr[esi+eax] >= 'A' && byte ptr[esi+eax] <= 'Z'
               add     byte ptr[esi+eax], 20h   ; add 20h to upper case bit
         .endif
            inc     eax
            dec     ecx
      .endw

NoExt:
      .if rd.Index == 1 || rd.Index == 2
            mov     szExt, 0
      .endif
         lea     eax, szExt
         mov     rd.lpExt, eax

      .if byte ptr szExt == 0 ||\
          byte ptr szExt == 'e' && byte ptr szExt+2 == 'e' ||\
          byte ptr szExt == 'i' && byte ptr szExt+2 == 'o' ||\
          byte ptr szExt == 'c' && byte ptr szExt+2 == 'r'
      .else
           push     ebx
            mov     dh, byte ptr szExt
            mov     dl, byte ptr szExt+1
            mov     bl, byte ptr szExt+2
            lea     esi, ExtArray
            xor     edi, edi
            mov     ecx, 42
         .while (ecx)
               mov     eax, [esi+edi*4]
            .if byte ptr[eax+1] == dh && byte ptr[eax+2] == dl && byte ptr[eax+3] == bl
;                  mov     eax, ImageIDS[edi*4]
;                  mov     dh, al
;                  mov     eax, rd.Index
;                  mov     ah, dh
;                  mov     rd.Index, eax
                  mov     eax, ImageIDS[edi*4]
                  shl     eax, 16
                  mov     edx, rd.Index
                  mov     ax, dx
                  mov     rd.Index, eax
               .break
            .endif
               inc     edi
               dec     ecx
         .endw
            pop     ebx
      .endif

         mov     eax, MAXDWORD
        imul     eax, FindData.nFileSizeHigh
         add     eax, FindData.nFileSizeLow
         mov     rd.lpSize, eax
         add     ListTotS, eax
;inc     Test4
;.if Test4 < 11

      INVOKE     FileTimeToLocalFileTime, addr FindData.ftLastWriteTime, addr Lft
      INVOKE     FileTimeToSystemTime, addr Lft, addr time
        call     fmtime
         mov     rd.lpDate, eax

      INVOKE     lstrcpy, addr szAttr, addr szFill
         lea     edx, szAttr
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_READONLY)
            mov     byte ptr[edx], 'r'
      .endif
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_ARCHIVE)
            mov     byte ptr[edx+1], 'a'
      .endif
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)
            mov     byte ptr[edx+2], 'h'
         .if !ShowHidden
               jmp     GetemLV
         .endif
      .endif
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM)
            mov     byte ptr[edx+3], 's'
      .endif
         lea     eax, szAttr
         mov     rd.lpAttr, eax

         inc     Row
      INVOKE     SendMessage, hWndListL[ebx*4], CM_ADDROW, 0, addr rd
         jmp     GetemLV

AllDoneLV:
      INVOKE     FindClose, hFind

DoFill:
      INVOKE     SendMessage, hWndListL[ebx*4], LB_GETCOUNT, 0, 0
         mov     CntL[ebx*4], eax

      .if ActiveList == 0
          MOVmd     ListTotNL, ListTotN
          MOVmd     ListTotSL, ListTotS
          MOVmd     ListSelN, ListSelNL
          MOVmd     ListSelS, ListSelSL
      .else
          MOVmd     ListTotNR, ListTotN
          MOVmd     ListTotSR, ListTotS
          MOVmd     ListSelN, ListSelNR
          MOVmd     ListSelS, ListSelSR
      .endif
      INVOKE     StatusBar, ListSelS, ListTotS, ListSelN, ListTotN

         mov     rd.lpName, 0
         mov     rd.lpExt, 0
         mov     rd.lpSize, 0
         mov     rd.lpDate, 0
         mov     rd.lpAttr, 0
         mov     rd.Index, 0
         mov     FillL[ebx*4], 0

      INVOKE     GetClientRect, hWndListL[ebx*4], addr rect
        push     rect.bottom
      INVOKE     GetClientRect, hWnd, addr rect
      INVOKE     SendMessage, hWndListL[ebx*4], CM_GETROWHEIGHT, 0, 0
         pop     esi
.if !rect.bottom && WBottom
    MOVmd     rect.bottom, WBottom
      mov     esi, LBottom
.endif
         mov     edx, rect.bottom
         sub     edx, esi
      .if !esi
            mov     edx, 112
      .endif
         mov     ecx, eax
         mov     eax, rect.bottom
         sub     eax, edx ;110
.if sdword ptr eax < 0
      xor     eax, eax
.endif
         xor     edx, edx
         div     ecx
.if eax
         dec     eax
.endif
      .if CntL[ebx*4] < eax
            mov     edi, eax
            sub     edi, CntL[ebx*4]
         .while (edi)
               mov     FillL[ebx*4], 1
            INVOKE     SendMessage, hWndListL[ebx*4], CM_ADDROW, 0, addr rd
               dec     edi
         .endw
      .endif

      INVOKE     SendMessage, hWndListL[ebx*4], CM_COLUMNSORT, 0, 0
         mov     ecx, SortL[ebx*8]       ; Column
         mov     edx, SortL[ebx*8+4]     ; Ascending or Descending
      .if Row < 2000                     ; Takes to long to do a second sort for large files
            add     edx, 3
         INVOKE     SendMessage, hWndListL[ebx*4], CM_COLUMNSORT, ecx, edx ; wParam=Col, lParam=0=Asc, 1=Desc
      .endif

         mov     edi, hPathL[ebx*4]
         xor     eax, eax
      .if !ActiveList
            mov     al, byte ptr szListPathL
            sub     al, 'A'
           imul     eax, sizeof HPATH
            add     edi, eax
         INVOKE     lstrcpy, addr [edi].HPATH.szPath, addr szListPathL
      .else
            mov     al, byte ptr szListPathR
            sub     al, 'A'
           imul     eax, sizeof HPATH
            add     edi, eax
         INVOKE     lstrcpy, addr [edi].HPATH.szPath, addr szListPathR
      .endif

NoFileLV:
         ret

LoadFiles ENDP

;===================================================
; Extract Extent PROCEDURE
;===================================================
GetExtent PROC

      INVOKE     lstrlen, addr szRootPath
      .while (eax)
            dec     eax
         .if szRootPath[eax] == '.'
            .break
         .endif
      .endw
      .if !eax
            mov     szExt, 0
            ret
      .endif
      INVOKE     lstrcpy, addr szExt, addr szRootPath[eax]
         ret

GetExtent ENDP

;===================================================
; Extract FileName PROCEDURE
;===================================================
GetFileName PROC

      INVOKE     lstrlen, addr szRootPath
      .while (eax)
            dec     eax
         .if szRootPath[eax] == '\'
            .break
         .endif
      .endw
         inc     eax
      INVOKE     lstrcpy, addr szFileName, addr szRootPath[eax]
         ret

GetFileName ENDP

;===================================================
; Remove FileName PROCEDURE
;===================================================
RemFileName PROC

      INVOKE     lstrlen, addr szRootPath
      .while (eax)
            dec     eax
         .if szRootPath[eax-1] == '\'
            .break
         .endif
      .endw
         inc     eax
      INVOKE     lstrcpyn, addr szRootPath, addr szRootPath, eax
         ret

RemFileName ENDP

;===================================================
; Remove Extent PROCEDURE
;===================================================
RemExtent PROC

      INVOKE     lstrlen, addr szFileName
      .while (eax)
            dec     eax
         .if szFileName[eax-1] == '.'
            .break
         .endif
      .endw
         inc     eax
      INVOKE     lstrcpyn, addr szFileName, addr szFileName, eax
         ret

RemExtent ENDP

;===============================================================
; Get Disk Space and set Header Title PROCEDURE
;===============================================================
GetHeader PROC uses ebx edi
LOCAL    dw1:DWORD, dw2
LOCAL    szVol[32]:BYTE, szHeader[64]:BYTE, szAvail[32]:BYTE, szTotal[32]:BYTE

         mov     szHeader, 0
;      .if byte ptr szDrv+1 == 3ah  ; ':'
         INVOKE     GetVolumeInformation, addr szDrv, addr szVol, 20, 0, addr dw1, addr dw2, 0, 0
         .if !eax
; Do message
               ret
         .endif
         INVOKE     lstrcpy, addr szHeader, addr szBL
         INVOKE     lstrcat, addr szHeader, addr szVol
         INVOKE     lstrcat, addr szHeader, addr szBR
         INVOKE     GetDiskFreeSpaceEx, addr szDrv, addr AvailQ, addr TotalQ, addr TFreeQ
          finit
            fld     OneK
           fild     AvailQ
           fdiv     ST(0), ST(1)
          fistp     AvailD
           fild     TotalQ
           fdiv     ST(0), ST(1)
          fistp     TotalD
         INVOKE     BaseAscii, AvailD, addr szAvail, 1, 10, 1, 1, 1
         INVOKE     BaseAscii, TotalD, addr szTotal, 16, 10, 1, 0, 1
         INVOKE     lstrcat, addr szHeader, addr szAvail
         INVOKE     lstrcat, addr szHeader, addr szOf
         INVOKE     lstrcat, addr szHeader, addr szTotal
         INVOKE     lstrcat, addr szHeader, addr szKFree
;      .else
;         INVOKE     lstrcpy, addr SavPath, addr szWork
;      .endif

      .if ActiveList == 0
         INVOKE     lstrcpy, addr szPathL, addr szPath
         INVOKE     SetWindowText, hSelBarL, addr szPathL
         INVOKE     SetWindowText, hStaticL, addr szHeader
      .else
         INVOKE     lstrcpy, addr szPathR, addr szPath
         INVOKE     SetWindowText, hSelBarR, addr szPathR
         INVOKE     SetWindowText, hStaticR, addr szHeader
      .endif
         mov     al, byte ptr szDrv
      .if al < 61h
            add     al, 20h
      .endif
         mov     byte ptr szCombo+2, al

         mov     ebx, ActiveList
      INVOKE     SendMessage, hComboL[ebx*4], CB_FINDSTRINGEXACT, -1, addr szCombo
         mov     edi, eax
      INVOKE     SendMessage, hComboL[ebx*4], CB_SETCURSEL, edi, 0
         add     edi, 1000                                   ; Start ID of drive toolbars
      INVOKE     SendMessage, hWndDrives, TB_ISBUTTONCHECKED, edi, 0
      .if !eax
         INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtL, FALSE
         INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, SavButtR, FALSE
         INVOKE     SendMessage, hWndDrives, TB_CHECKBUTTON, edi, TRUE
      .endif
         mov     SavButtL[ebx*4], edi
         xor     ecx, ecx
         mov     cx, -1
      INVOKE     SendMessage, hComboR, CB_SETEDITSEL, 0, ecx   ; ?????????
         ret

GetHeader ENDP

;=====================================================================
; Converts a Dec, Hex, Oct or Bin ascii string to a 32 bit num value.
;=====================================================================
AsciiBase PROC Input:DWORD, Output, Base
      pushad
         mov     esi, Input
         mov     edi, Output
         and     dword ptr[edi], 0
      INVOKE     lstrlen, Input
         xor     ecx, ecx
      .while (eax)
         .if byte ptr[esi+ecx] > 60h
               sub     byte ptr[esi+ecx], 57h
         .elseif byte ptr[esi+ecx] > 40h
               sub     byte ptr[esi+ecx], 37h
         .else
               xor     byte ptr[esi+ecx], 30h
         .endif
            dec     eax
            inc     ecx
      .endw
         mov     ebx, 1
         mov     esi, Input
         add     esi, ecx
         dec     esi
         xor     edx, edx
      .while (ecx)
            mov     al, byte ptr[esi]      ; Extract byte for conversion
            and     eax, 000000ffh
           imul     eax, ebx
            add     dword ptr[edi], eax    ; Accumulate output
           imul     ebx, Base
            dec     esi
            dec     ecx 
      .endw
       popad
          ret
AsciiBase ENDP

;=========================================================================
;  Converts a 32 bit num value to a Dec, Hex, Oct or Bin ascii string.
;=========================================================================
;INVOKE     BaseAscii, cnt, offset num, 2, 10, 0, 1, 0
BaseAscii PROC InPut:DWORD, OutPut, LEN, Base, Comma, Fill, TermA
LOCAL    LBuff[32]: BYTE

      pushad
         xor     esi, esi
         mov     eax, InPut                ; Input
         mov     ebx, OutPut
         mov     byte ptr [ebx], '0'
      .while (eax)
            xor     edx, edx
            div     Base                   ; Base 10, 16, 8, 2
         .if dl > 9h
               add     dl, 37h             ; Convert to hex ASCII
         .else
               add     dl, 30h             ; Convert to dec ASCII
         .endif
            mov     LBuff[esi], dl
            inc     esi
         .if Comma == 1 && Base == 10 && eax > 0
            .if esi == 3 || esi == 7 || esi == 11
                  mov     LBuff[esi], 2ch  ; Insert commas
                  inc     esi
            .endif
         .endif
      .endw
         xor     edi, edi
         mov     ecx, esi
      .if LEN > ecx && Fill == 1           ; Zero fill
            xor     eax, eax
         .while (eax < LEN)
               mov     byte ptr [ebx+eax], '0'
               inc     eax
         .endw
            sub     LEN, ecx
            add     edi, LEN
      .endif
      .while (ecx)
            mov     al, byte ptr LBuff[esi-1]
            mov     byte ptr [ebx+edi], al
            inc     edi
            dec     esi
            dec     ecx
      .endw
      .if TermA
         mov     byte ptr [ebx+edi], 0h
      .endif
       popad
         ret

BaseAscii ENDP

;===================================================
; Fills a buffer with a character.
;===================================================
FillBuffer PROC uses esi edi Input:DWORD, SizeB:DWORD, FillChar:BYTE, TermA:DWORD

         mov     esi, Input
         mov     edi, esi           ; Dest = Source
         mov     ecx, SizeB         ; Size to fill
         mov     al, FillChar       ; Fill character

FillBuff:
       stosb                        ; Store al
        loop     FillBuff           ; for length of string
      .if TermA                     ; Write a terminating char
            dec     edi
            mov     byte ptr[edi], 0
      .endif
         ret

FillBuffer ENDP

;==========================================================
; ContextMenu PROCEDURE
;==========================================================
ContextMenu PROC uses ebx esi edi pshfParent:LPSHELLFOLDER, pidl:LPITEMIDLIST
LOCAL    pcm:LPCONTEXTMENU
LOCAL    cmi:CMINVOKECOMMANDINFO
LOCAL    ft:FILETIME
LOCAL    pt:POINT
LOCAL    Cnt:DWORD, lpVerb, iCmd, hReg, IndexNum, PathSize, ValueSize, Val
LOCAL    szText[64]:BYTE, szBuff0[256]:BYTE, szString[512]:BYTE
LOCAL    szData[150]:BYTE

         and     ImageID, 0
         and     NumPgms, 0
      .if FileTyp == 3
           call     GetExtent
      .endif
      INVOKE     lstrcpy, addr szBuff0, addr szFileExts
      INVOKE     lstrcat, addr szBuff0, addr szExt
      INVOKE     lstrcat, addr szBuff0, addr szRegOWL
      INVOKE     RegOpenKeyEx, HKEY_CURRENT_USER, addr szBuff0, 0, KEY_READ, addr hReg
      .if eax
; Error
            jmp     NoOpenList
      .endif
         lea     edi, PgmTextArray
         xor     ebx, ebx
         mov     IndexNum, 0
         and     PaintOn, 0

Loop4:
         mov     PathSize, sizeof szRegPath
         mov     lpcbData, sizeof szData
      INVOKE     RegEnumValue, hReg, IndexNum, addr szRegPath, addr PathSize, 0,\
                 addr szREGSZ, addr szData, addr lpcbData
      .if eax == ERROR_NO_MORE_ITEMS || ebx > 7
            mov     NumPgms, ebx
            jmp     NoMore
      .endif

      .if byte ptr szRegPath == 'M' && byte ptr szRegPath+2 == 'U'
            mov     ecx, 8
         INVOKE     lstrcpy, [edi+ecx*4], addr szData

      .else
         INVOKE     lstrcpy, addr szBuff0, addr szApplication
         INVOKE     lstrcat, addr szBuff0, addr szData
         INVOKE     lstrcat, addr szBuff0, addr szRegSOC
            mov     lpcbData, sizeof szRegValue
         INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szBuff0, addr szRegValue, addr lpcbData
         .if eax != ERROR_SUCCESS
            INVOKE     lstrcpy, addr szBuff0, addr szApplication
            INVOKE     lstrcat, addr szBuff0, addr szData
            INVOKE     lstrcat, addr szBuff0, addr szRegSEC
               mov     lpcbData, sizeof szRegValue
            INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szBuff0, addr szRegValue, addr lpcbData
            .if eax != ERROR_SUCCESS
                  jmp     Pass1
            .endif
               mov     PaintOn, 1
         .endif
         .if byte ptr szRegPath >= 'a' && byte ptr szRegPath <= 'z'
            INVOKE     lstrcpy, [edi+ebx*4], addr szData
               inc     ebx
         .endif

Pass1:
      .endif
         inc     IndexNum
         jmp     Loop4

NoMore:
      INVOKE     RegCloseKey, hReg
      .if !IndexNum
            jmp     NoOpenList
      .endif

NoOpenList:
      INVOKE     GetCursorPos, addr pt
         mov     ebx, ActiveList

      COVOKE     pshfParent, IShellFolder, GetUIObjectOf,\
                 hWnd, 1, addr pidl, addr IID_IContextMenu, 0, addr pcm
        test     eax, eax
          js     RetError

         mov     mii.cbSize, sizeof mii
         mov     mii.fMask,\
                 MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE or MIIM_CHECKMARKS

      INVOKE     CreatePopupMenu
        test     eax, eax
         jz      RetError
         mov     hSMenu, eax

      INVOKE     vf(pcm, IContextMenu, QueryInterface),\
                 addr IID_IContextMenu2, addr pcm2

;7fffh
      INVOKE     vf(pcm, IContextMenu, QueryContextMenu),\
                 hSMenu, 0, 0, 400, CMF_EXPLORE or CMF_NORMAL or CMF_CANRENAME
        test     eax, eax
          js     RetError

      INVOKE     GetMenuItemCount, hSMenu
         mov     edi, eax
         xor     ebx, ebx
      .while (edi)
            mov     szText, 0
            lea     eax, szText
            mov     mii.dwTypeData, eax
            mov     mii.cch, sizeof szText
         INVOKE     GetMenuItemInfo, hSMenu, ebx, TRUE, addr mii
         .if mii.fType == MFT_OWNERDRAW
              call     LoadImageFile
             MOVmd     ImageID, mii.wID
            .break
         .endif
            inc     ebx
            dec     edi
      .endw
jmp     UsePcm2

;         mov     mii.fType, MFT_STRING
      INVOKE     GetMenuItemCount, hSMenu
         mov     edi, eax
         xor     ebx, ebx
      .while (edi)
            lea     eax, szText
            mov     mii.dwTypeData, eax
            mov     mii.cch, sizeof szText
         INVOKE     GetMenuItemInfo, hSMenu, ebx, TRUE, addr mii
         INVOKE     lstrcmpi, addr szOpenWith, addr szText
         .if !eax
               mov     eax, mii.hSubMenu
               mov     hSubMenu, eax
            INVOKE     DeleteMenu, hSubMenu, 0, MF_BYPOSITION
               mov     Cnt, 6002
               lea     esi, PgmTextArray
               xor     ebx, ebx
            .while (NumPgms)
                  mov     mii.fType, MFT_OWNERDRAW ;MFT_STRING MFT_OWNERDRAW
                  mov     mii.fState, MFS_ENABLED
                  mov     eax, Cnt
                  mov     mii.wID, eax
                  mov     mii.hSubMenu, 0
                  mov     mii.hbmpChecked, 0
                  mov     mii.hbmpUnchecked, 0
                  mov     mii.dwItemData, eax
                  mov     eax, [esi+ebx*4]
                  mov     mii.dwTypeData, eax
               INVOKE     InsertMenuItem, hSubMenu, 1, TRUE, addr mii
                  inc     ebx
                  inc     Cnt
                  dec     NumPgms
            .endw
               mov     mii.fType, MFT_SEPARATOR
               mov     mii.wID, 0
               mov     mii.dwTypeData, 0
            INVOKE     InsertMenuItem, hSubMenu, 20, TRUE, addr mii

               mov     mii.fType, MFT_STRING
               mov     mii.fState, MFS_ENABLED
               mov     mii.wID, 7001
               mov     mii.dwItemData, 7001
               lea     eax, offset szChoose
               mov     mii.dwTypeData, eax
            INVOKE     InsertMenuItem, hSubMenu, 20, TRUE, addr mii
            .break
         .endif
            inc     ebx
            dec     edi
      .endw

UsePcm2:
      .if FileTyp == 3
            mov     mii.fType, MFT_OWNERDRAW
            mov     mii.fState, MFS_ENABLED
            mov     mii.wID, 6001
            mov     mii.hSubMenu, 0
            mov     mii.hbmpChecked, 0
            mov     mii.hbmpUnchecked, 0
            mov     mii.dwItemData, 6001
            lea     eax, offset szEdit
            mov     mii.dwTypeData, eax
         INVOKE     InsertMenuItem, hSMenu, 1, TRUE, addr mii
      .endif

      INVOKE     GetMenuItemCount, hSMenu
         mov     ebx, eax
         sub     ebx, 6
         mov     ecx, MFS_GRAYED
      .if szPastePath
            mov     ecx, MFS_ENABLED
      .endif
         mov     mii.fType, MFT_STRING
         mov     mii.fState, ecx
         mov     mii.wID, 6097
         mov     mii.dwItemData, 6097
         lea     eax, offset szPaste
         mov     mii.dwTypeData, eax
      INVOKE     InsertMenuItem, hSMenu, ebx, TRUE, addr mii

      INVOKE     GetMenuItemCount, hSMenu
         mov     ebx, eax
         sub     ebx, 4
         mov     mii.fType, MFT_STRING
         mov     mii.fState, MFS_ENABLED
         mov     mii.wID, 6098
         mov     mii.dwItemData, 6098
         lea     eax, offset szShortCut
         mov     mii.dwTypeData, eax
      INVOKE     InsertMenuItem, hSMenu, ebx, TRUE, addr mii

         mov     ebx, ActiveList ;hWndListL[ebx*4]
      INVOKE     TrackPopupMenu, hSMenu, TPM_LEFTALIGN or TPM_RIGHTBUTTON or TPM_RETURNCMD,
                 pt.x, pt.y, 0, hWnd, 0
        test     eax, eax
          jz     RetError

;mov     eax, 6bh
push     eax
;mov     edx, eax
;DSPValue hWnd, eax, 1, 't'
         sub     eax, IDM_FIRST
         mov     cmi.lpVerb, eax
         mov     ecx, eax
      INVOKE     vf(pcm, IContextMenu, GetCommandString), ecx,\
                 GCS_VERBA, NULL, addr szText, sizeof szText
      .if (eax == S_OK)
            lea     eax, szText
            mov     lpVerb, eax
;INVOKE     MessageBox, NULL, addr szText, addr AppName, MB_OK
      .endif
pop     eax
;Pass:

         mov     iCmd, eax
         mov     Cmd, eax
         mov     cmi.cbSize, sizeof CMINVOKECOMMANDINFO
         mov     cmi.fMask, 0
         mov     eax, hWnd
         mov     cmi.hwnd, eax
         mov     eax, iCmd
;         dec     eax
         and     eax, 0000FFFFh
         mov     cmi.lpVerb, eax
         mov     cmi.lpParameters, 0
         mov     cmi.lpDirectory, 0
         mov     cmi.nShow, SW_SHOWNORMAL  ; or SW_HIDE
;.if sw2 == 10
;         mov     cmi.nShow, SW_HIDE
;.endif
         mov     cmi.dwHotKey, 0
         mov     cmi.hIcon, 0
      INVOKE     vf(pcm, IContextMenu, InvokeCommand), addr cmi
      .if eax != 0 ; Failed non zero may not be a failure
; Send error message
      .endif

      .if Cmd == 6001
         .if szEditPgr
            INVOKE     lstrcpy, addr szString, addr szEditPgr
            INVOKE     lstrcat, addr szString, addr szSpace
            INVOKE     lstrcat, addr szString, addr szRootPath
            INVOKE     WinExec, addr szString, SW_SHOWNORMAL     ; Exec a program
            .if eax < 32
; error
            .endif
         .else
; Do message
         .endif

;-------- [Rename
      .elseif Cmd == 18
            mov     esi, ActiveList
         INVOKE     SendMessage, hWndListL[esi*4], CM_ENTEREDIT, 44, SavRow

;-------- [Cut
      .elseif Cmd == 24
         INVOKE     lstrcpy, addr szPastePath, addr szRootPath
         INVOKE     lstrcpy, addr szBuffFr, addr szRootPath
            mov     esi, ActiveList
            mov     ecx, esi
            add     ecx, 2000
         INVOKE     SendMessage, hWnd, WM_COMMAND, ecx, 0

            mov     ebx, SavRow
            shl     ebx, 16
            mov     bx, 5
         INVOKE     SendMessage, hWndListL[esi*4], CM_GETCELLDATA, ebx, addr Val
            mov     ecx, Val
            add     cx, 8
            mov     Val, ecx
         INVOKE     SendMessage, hWndListL[esi*4], CM_SETCELLDATA, ebx, addr Val
;            mov     Funct, IDM_DELETE
;           call     DoFileOperation

;-------- [Copy
      .elseif Cmd == 25
         INVOKE     lstrcpy, addr szPastePath, addr szRootPath

;-------- [Paste
      .elseif Cmd == 6097
            mov     Funct, IDM_PASTE
         INVOKE     lstrcpy, addr szBuffFr, addr szPastePath
         .if !ActiveList
            INVOKE     lstrcpy, addr szBuffTo, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szBuffTo, addr szListPathR
         .endif
         .if FileTyp != 3
            INVOKE     lstrcat, addr szBuffTo, addr szFileName
            INVOKE     lstrcat, addr szBuffTo, addr szSlashB
         .endif
         INVOKE     lstrcpy, addr szWork, addr szCopyD
           call     DoFileOperation

;-------- [Open with
;      .elseif Cmd > 6001 && Cmd < 6010
;DSPValue hWnd, 4444, 1, 'm'
;            mov     ecx, Cmd
;            sub     ecx, 6002
;            lea     esi, PgmTextArray
;         INVOKE     lstrcpy, addr szText, [esi+ecx*4]
;         INVOKE     lstrcpy, addr szRegPath, addr szApplication
;         INVOKE     lstrcat, addr szRegPath, addr szText
;         INVOKE     lstrcat, addr szRegPath, addr szRegSOC
;            mov     lpcbData, sizeof szRegValue
;         INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szRegPath, addr szRegValue, addr lpcbData
;         .if eax != ERROR_SUCCESS
;            INVOKE     lstrcpy, addr szRegPath, addr szApplication
;            INVOKE     lstrcat, addr szRegPath, addr szText
;            INVOKE     lstrcat, addr szRegPath, addr szRegSEC
;               mov     lpcbData, sizeof szRegValue
;            INVOKE     RegQueryValue, HKEY_CLASSES_ROOT, addr szRegPath, addr szRegValue, addr lpcbData
;            .if eax != ERROR_SUCCESS
;;               INVOKE     SetWindowLong, hWnd, GWL_WNDPROC, lpContext2
;                  ret
;            .endif
;         .endif
;;INVOKE     MessageBox, NULL, addr szRegValue, addr AppName, MB_OK
;         INVOKE     lstrlen, addr szRegValue
;            mov     ebx, eax
;            sub     eax, 2
;         .if byte ptr szRegValue[eax] == '%'
;               sub     ebx, 2
;         .elseif byte ptr szRegValue[eax-1] == '%'
;               sub     ebx, 4
;         .endif
;         INVOKE     lstrcpyn, addr szRegValue, addr szRegValue, ebx
;;INVOKE     MessageBox, NULL, addr szRegValue, addr AppName, MB_OK
;         INVOKE     lstrcmpi, addr szPgmName, addr szText
;         .if !eax
;            INVOKE     lstrcat, addr szRegValue, addr szPercent1M
;         .else
;            INVOKE     lstrcat, addr szRegValue, addr szSpace
;         .endif
;;INVOKE     MessageBox, NULL, addr szRegValue, addr AppName, MB_OK
;         INVOKE     lstrcpy, addr szString, addr szRegValue
;.if byte ptr szRegValue+1 != 'u' && byte ptr szRegValue+8 != '.'
;         INVOKE     lstrcat, addr szString, addr szQuote
;.endif
;         INVOKE     lstrcat, addr szString, addr szRootPath
;.if byte ptr szRegValue+1 != 'u' && byte ptr szRegValue+8 != '.'
;         INVOKE     lstrcat, addr szString, addr szQuote
;.endif
;;INVOKE     MessageBox, NULL, addr szString, addr AppName, MB_OK
;         INVOKE     WinExec, addr szString, SW_SHOWNORMAL     ; Exec a program
;         .if eax < 32
;; error
;         .endif
;rundll32.exe shimgvw.dll,ImageView_Fullscreen L:\AsmEdit\Projects\FileMan4\Res\B16_EXIT.bmp
      .elseif Cmd == 6098
           call     DoShortcut

      .elseif Cmd == 7001
         INVOKE     lstrcpy, addr szString, addr szChoosePgm
         INVOKE     lstrcat, addr szString, addr szRootPath
         INVOKE     WinExec, addr szString, SW_SHOWNORMAL     ; Exec a program
         .if eax < 32
; error
         .endif
      .endif

RetError:
      .if ipPicture
            mov     eax, ipPicture
           push     eax
            mov     edx, dword ptr[eax]
           call     dword ptr[edx+8]          ; ipPicture->Release()
         INVOKE     DeleteObject, hBitmap
            and     ipPicture, 0
      .endif

      INVOKE     DestroyMenu, hSMenu
      INVOKE     DestroyMenu, hSubMenu
      COVOKE     pcm, IUnknown, Release
      .if pcm2
;         INVOKE     vf(pcm2, IUnknown, Release)
         COVOKE     pcm2, IUnknown, Release
            mov     pcm2, 0
      .endif

RetOk:
         mov     eax, 1
         ret
         
ContextMenu ENDP

;===================================================
; IDList_CopyItem PROCEDURE
;===================================================
IDList_CopyItem PROC uses ebx edx ecx edi esi pidl:LPITEMIDLIST
LOCAL      pidlNew:LPITEMIDLIST
LOCAL      w4:DWORD

      .if !pidl
            jmp     ret_null
      .endif
         mov     ebx, pidl 
       movsx     edx, (ITEMIDLIST PTR [ebx]).mkid.cb  ; D I E D from tree
         add     edx, sizeof WORD
         mov     w4, edx
;         mov     edx, pShellMalloc
;         mov     edx, [edx]
;      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, w4
      COVOKE     pShellMalloc, IMalloc, Alloc, w4
        test     eax,eax
         jz      ret_null
         mov     pidlNew, eax
         mov     esi, pidl
         mov     edi, pidlNew
         mov     ecx, w4
      .while (ecx != 0)
            mov     al,byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .endw

RetOk:
         mov     eax, pidlNew
         ret
ret_null:
         xor     eax,eax
         ret
IDList_CopyItem ENDP

;===================================================
; IDList_GetSize PROCEDURE
;===================================================
IDList_GetSize PROC uses ebx pidl:LPITEMIDLIST
LOCAL    cbTotal:DWORD

         mov     cbTotal, 0
      .if pidl != 0
            mov     ebx, pidl
start_loop:
          movsx     eax, (ITEMIDLIST PTR [ebx]).mkid.cb
           test     eax, eax
            jz      end_loop
            add     cbTotal, eax
            add     ebx, eax
            jmp     start_loop
end_loop:                                   
      .endif       
         mov     eax, cbTotal
;DSPValue hWndP, cbTotal, 1, 'm'
         ret

IDList_GetSize ENDP

;===================================================
; IDList_Combine PROCEDURE
;===================================================
IDList_Combine PROC uses esi edi ecx edx pidl1:LPITEMIDLIST, pidl2:LPITEMIDLIST
LOCAL    pidlNew:LPITEMIDLIST
LOCAL    cb1:DWORD
LOCAL    cb2:DWORD
      
;----- [Get length of 1st pidl (not including NULL terminating word)] -----
      INVOKE     IDList_GetSize, pidl1
         mov     cb1, eax
      
;----- [Get length of 2nd pidl (not including NULL terminating word)] -----
      INVOKE     IDList_GetSize, pidl2
         mov     cb2, eax
      
;----- [Get total length of resulting combined pidl (including NULL terminating word)] -----
         mov     eax, sizeof ITEMIDLIST.mkid.cb
         add     eax, cb1
         add     eax, cb2  

;----- [Allocate the memory] -----
;         mov     edx, pShellMalloc
;         mov     edx,[edx]
;      INVOKE     (IMalloc PTR [edx]).Alloc, pShellMalloc, eax
      COVOKE     pShellMalloc, IMalloc, Alloc, eax
        test     eax,eax
         jz      RetError
         mov     pidlNew, eax
      
;----- [Set destination] -----
         mov     edi, eax
      
;----- [Write 1st pidl to destination (pidlNew)] -----
         mov     esi, pidl1
         mov     ecx, cb1
      .WHILE ecx != 0
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .ENDW             

;----- [Write 2nd pidl after 1st] -----
         mov     esi, pidl2
         mov     ecx, cb2
      .WHILE ecx != 0
            mov     al, byte ptr [esi]
            mov     byte ptr [edi], al       
            dec     ecx            
            inc     esi
            inc     edi
      .ENDW             
      
;----- [Add terminating word] -----
         mov     word ptr [edi], 0
         mov     eax, pidlNew
         ret

RetError:
         xor     eax, eax
         ret
IDList_Combine ENDP

;===================================================
; Get a pidl from a Path PROCEDURE
;===================================================
PathToPidl PROC Code
LOCAL    sfi:SHFILEINFO
LOCAL    pidl:LPITEMIDLIST
LOCAL    pidlRel:LPITEMIDLIST
LOCAL    plvobj:LPLV_OBJDATA
LOCAL    strret:STRRET
LOCAL    pchEaten:DWORD, peidl, pidlFull, dwFlags
LOCAL    dwAttr[4]:DWORD
LOCAL    SavPath[256]:BYTE, szBuff[256]:BYTE, szBuff1[256]:BYTE

      INVOKE     GetFileAttributes, addr szRootPath
         mov     dwAttr, eax

;DSPValue hWnd, eax, 1, 'm'
      INVOKE     SetFileAttributes, addr szRootPath, FILE_ATTRIBUTE_ARCHIVE ; In case the file is read only
      INVOKE     lstrcpy, addr szBuff1, addr szRootPath
        call     RemFileName
      INVOKE     lstrcpy, addr SavPath, addr szRootPath
      INVOKE     lstrcpy, addr szRootPath, addr szBuff1

INVOKE     GetFileAttributes, addr SavPath
   mov     dwAttr+4, eax
INVOKE     SetFileAttributes, addr SavPath, FILE_ATTRIBUTE_ARCHIVE

;INVOKE     MessageBox, NULL, addr SavPath, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szRootPath, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szFileName, addr AppName, MB_OK
;L:\AsmEdit\Projects\FileMan4\

;-------------- [Converts ASCII to UNICODE] -------------
      INVOKE     MultiByteToWideChar, CP_ACP, MB_PRECOMPOSED, addr SavPath, -1, addr szBuff, 255
      INVOKE     SHGetDesktopFolder, addr pshf
        test     eax, eax
          js     RetError

;-------------- [Creates a pidl from a path] -------------
      COVOKE     pshf, IShellFolder, ParseDisplayName, hWnd, 0,\
                 addr szBuff, addr pchEaten, addr pidlBase, 0
        test     eax, eax
          js     RetError

;-------------- [Bindes the folder] -------------
      COVOKE     pshf, IShellFolder, BindToObject, pidlBase,\
                 0, addr IID_IShellFolder, addr pshf
        test     eax, eax
          js     RetError

         mov     dwFlags, SHCONTF_FOLDERS or SHCONTF_NONFOLDERS or SHCONTF_INCLUDEHIDDEN ;or\
; 256 SHCONTF_INIT_ON_FIRST_NEXT
;--------------- [Get the id lists from the parent folder] --------------- 
      COVOKE     pshf, IShellFolder, EnumObjects, hWnd, dwFlags, addr peidl
        test     eax, eax
          js     RetError
      .if Code
            jmp     RetOk
      .endif

FillLoop:
      COVOKE     peidl, IEnumIDList, Next, 1, addr pidl, NULL
        test     eax, eax
          js     RetError
         cmp     eax, S_FALSE    ; No more items, S_FALSE = 1
          jz     End_ObjectLoop

;         mov     eax, pShellMalloc
;         mov     eax, [eax]
;      INVOKE     (IMalloc ptr [eax]).Alloc, pShellMalloc, sizeof LV_OBJDATA ; Size = 24 bytes
      COVOKE     pShellMalloc, IMalloc, Alloc, sizeof LV_OBJDATA
      .if eax != 0
            mov     plvobj, eax  ; Memory pointer

;--------------- [Get full pidl] ---------------
         INVOKE     IDList_Combine, pidlBase, pidl
           test     eax, eax
             jz     RetError
            mov     pidlFull, eax

;--------------- [Save LV_OBJDATA struct] ---------------
;            mov     edx, plvobj
         INVOKE     IDList_CopyItem, pidl
            mov     pidlRel, eax

         INVOKE     SHGetFileInfo, pidlFull, 0, addr sfi, sizeof SHFILEINFO,
                    SHGFI_PIDL or SHGFI_DISPLAYNAME or SHGFI_TYPENAME
           test     eax, eax
             jz     RetError

         COVOKE     pShellMalloc, IMalloc, Free, pidl
         INVOKE     lstrcmpi, addr sfi.szTypeName, addr szShort
         .if !eax
            INVOKE     lstrcat, addr sfi.szDisplayName, addr szLn
         .endif
;INVOKE     MessageBox, NULL, addr szFileName, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr sfi.szDisplayName, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr sfi.szTypeName, addr AppName, MB_OK
         INVOKE     lstrcmpi, addr sfi.szDisplayName, addr szFileName
         .if !eax
            INVOKE     ContextMenu, pshf, pidlRel
               jmp     RetOk
         .endif
      .endif
         jmp     FillLoop

End_ObjectLoop:

RetOk:
INVOKE     SetFileAttributes, addr szRootPath, dwAttr
INVOKE     SetFileAttributes, addr SavPath, dwAttr+4
         mov     eax, 1
         ret

RetError:
INVOKE     SetFileAttributes, addr szRootPath, dwAttr
INVOKE     SetFileAttributes, addr SavPath, dwAttr+4
         mov     eax, -1
         ret        
PathToPidl ENDP

;===================================================
; Create Shortcut PROCEDURE
;===================================================
DoShortcut PROC
LOCAL    pWide:DWORD, ppv, ppvObject, hResult, hHeap, pidlParent
LOCAL    szBuff1[256]:BYTE, szBuff2[512]:BYTE

      INVOKE     lstrcpy, addr szBuff1, addr szRootPath
      INVOKE     SHGetSpecialFolderLocation, hWnd, CSIDL_DESKTOP, addr pidlParent
      INVOKE     SHGetPathFromIDList, pidlParent, addr szBuff2
      INVOKE     lstrcat, addr szBuff2, addr szSlashB
      INVOKE     lstrcat, addr szBuff2, addr szSpace
        call     GetFileName
        call     RemExtent

;---------- [If link is to be on the Desktop
      INVOKE     lstrcat, addr szBuff2, addr szShortcut
;---------- [or if link is to be in Current Folder
;      INVOKE     lstrcpy, addr szBuff2, addr szShortcut
      INVOKE     lstrcat, addr szBuff2, addr szFileName
      INVOKE     lstrcat, addr szBuff2, addr szLnk

;Shortcut to XXXX.lnk                                                  -Current file
;C:\Documents and Settings\Ewayne Wagner\Desktop\ Shortcut to XXXX.lnk -Desktop

;---------- [First, get some heap for a wide buffer
      INVOKE     GetProcessHeap
         mov     hHeap, eax
      INVOKE     HeapAlloc, hHeap, NULL, MAX_PATH * 2
         mov     pWide, eax

;---------- [Get a pointer to the IShellLink interface
      INVOKE     CoCreateInstance, addr CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, addr IID_IShellLink, addr ppv
         mov     hResult, eax
        test     eax, eax

;---------- [Query IShellLink for the IPersistFile interface for saving the shortcut
      .if !eax
         COVOKE     ppv, IShellLink, QueryInterface, addr IID_IPersistFile, addr ppvObject
;            mov     edx, ppv
;            mov     edx, [edx]
;         INVOKE     (IShellLink PTR [edx]).QueryInterface, ppv, addr IID_IPersistFile, addr ppvObject

            mov     hResult, eax
           test     eax, eax

;---------- [Set the path to the shortcut target 
         .if !eax
            COVOKE     ppv, IShellLink, SetPath, addr szBuff1
               mov     hResult, eax

;---------- [Add the description, use first icon found
            COVOKE     ppv, IShellLink, SetIconLocation, addr szBuff1, 0 
               mov     hResult, eax

            INVOKE     MultiByteToWideChar, CP_ACP, 0, addr szBuff2, -1, pWide, MAX_PATH * 2

;---------- [Save the link by calling IPersistFile::Save
            COVOKE     ppvObject, IPersistFile, Save, pWide, TRUE
               mov     eax, hResult

;---------- [Release the IPersistFile ppvObject pointer
            COVOKE     ppvObject, IPersistFile, Release
               mov     hResult, eax
         .endif
         COVOKE     ppv, IShellLink, Release
            mov     hResult, eax
      .endif
;---------- [Free our heap space
      INVOKE     HeapFree, hHeap, NULL, pWide
         mov     eax, hResult    ; Since we reuse this variable over and over,
                                 ; it contains the last operations result
         ret

DoShortcut ENDP

;===================================================
; Display Properties PROCEDURE
;===================================================
;DoProperties PROC
;LOCAL    ShellInfo:SHELLEXECUTEINFO

;         mov     ShellInfo.cbSize, sizeof ShellInfo
;         mov     ShellInfo.fMask, SEE_MASK_INVOKEIDLIST or SEE_MASK_FLAG_NO_UI
;        push     hWnd
;         pop     ShellInfo.hwnd
;         mov     ShellInfo.lpVerb, offset szProperties
;         lea     eax, szRootPath
;         mov     ShellInfo.lpFile, eax
;         mov     ShellInfo.lpParameters, NULL
;         mov     ShellInfo.lpDirectory, NULL
;         mov     ShellInfo.nShow, NULL
;         mov     ShellInfo.hInstApp, NULL
;         mov     ShellInfo.lpIDList, NULL
;      INVOKE     ShellExecuteEx, addr ShellInfo
;         ret

;DoProperties ENDP

;===================================================
; Format the time and send it to the ConvDateTime structure
;===================================================
fmtime PROC ;Time:SYSTEMTIME
LOCAL    HoldT:DWORD

         and     HoldT, 0
       MOVmw     HoldT, time.wDay
      INVOKE     BaseAscii, HoldT, addr cdt.dda, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wMonth
      INVOKE     BaseAscii, HoldT, addr cdt.dmo, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wYear
      INVOKE     BaseAscii, HoldT, addr cdt.dyr, 4, 10, 0, 1, 0
      INVOKE     BaseAscii, HoldT, addr cdt.dyrs, 4, 10, 0, 1, 0
       MOVmw     HoldT, time.wHour
      INVOKE     BaseAscii, HoldT, addr cdt.dhour, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wMinute
      INVOKE     BaseAscii, HoldT, addr cdt.dmin, 2, 10, 0, 1, 0
       MOVmw     HoldT, time.wSecond
      INVOKE     BaseAscii, HoldT, addr cdt.dsec, 2, 10, 0, 1, 0
         lea     eax, cdt.dyrs ;dmo
         ret

fmtime ENDP

;===================================================
; StatusBar PROCEDURE
;===================================================
StatusBar PROC listSelS:DWORD, listTotS:DWORD, listSelN:DWORD, listTotN:DWORD
LOCAL    szBuff[16]:BYTE, szStatus[64]:BYTE

      INVOKE     BaseAscii, listSelS, addr szBuff, 1, 10, 1, 1, 1
      INVOKE     lstrcpy, addr szStatus, addr szBuff
      INVOKE     lstrcat, addr szStatus, addr szOf

      INVOKE     BaseAscii, listTotS, addr szBuff, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szBuff
      INVOKE     lstrcat, addr szStatus, addr szIn

      INVOKE     BaseAscii, listSelN, addr szBuff, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szBuff
      INVOKE     lstrcat, addr szStatus, addr szOf

      INVOKE     BaseAscii, listTotN, addr szBuff, 1, 10, 1, 1, 1
      INVOKE     lstrcat, addr szStatus, addr szBuff
      INVOKE     lstrcat, addr szStatus, addr szFiles

   .if ActiveList == 0
      INVOKE     lstrcpy, addr szStatusL, addr szStatus
      INVOKE     SendMessage, hWndStat, SB_SETTEXT, 1, addr szStatusL
   .else
      INVOKE     lstrcpy, addr szStatusR, addr szStatus
      INVOKE     SendMessage, hWndStat, SB_SETTEXT, 2, addr szStatusR
   .endif
         ret

StatusBar ENDP

;===================================================
; ChgBmpColor procedure
;===================================================
ChgBmpColor PROC hBMap:DWORD
LOCAL    mDC:DWORD, hNewBrush, hOldBmp, Fill, hOldBrush

      INVOKE     CreateCompatibleDC, NULL
         mov     mDC, eax
      INVOKE     SelectObject, mDC, hBMap
         mov     hOldBmp, eax
      INVOKE     GetSysColor, COLOR_BTNFACE
      INVOKE     CreateSolidBrush, eax
         mov     hNewBrush, eax
      INVOKE     SelectObject, mDC, hNewBrush
         mov     hOldBrush, eax
         mov     Fill, 00c0c0c0h
      INVOKE     ExtFloodFill, mDC, 0, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 0, 15, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 0, Fill, FLOODFILLSURFACE
      INVOKE     ExtFloodFill, mDC, 15, 15, Fill, FLOODFILLSURFACE
      INVOKE     SelectObject, mDC, hOldBrush
      INVOKE     DeleteObject, hNewBrush
      INVOKE     SelectObject, mDC, hBMap
        push     eax
      INVOKE     DeleteDC, mDC
         pop     eax
         ret

ChgBmpColor ENDP

;===================================================
; Shell notify procedure
;===================================================
DoSHNotify PROC uses ebx esi wParam:DWORD, lParam

mov     NotifyOn, 1
         mov     ecx, lParam
      .if ecx == SHCNE_CREATE || ecx == SHCNE_MKDIR || ecx == SHCNE_RENAMEITEM ||\
          ecx == SHCNE_DELETE || ecx == SHCNE_RMDIR
            xor     esi, esi
            mov     ebx, ActiveList
         INVOKE     SendMessage, hWndListL[ebx*4], CM_GETSCROLLPOS, 0, 0
         .if eax
               mov     esi, hWnd
         .endif
         INVOKE     LockWindowUpdate, esi
           call     Refresh
         INVOKE     SendMessage, hWndListL[ebx*4], CM_SETSCROLLPOS, 0, 0
         INVOKE     LockWindowUpdate, 0
         .if wParam                      ; Refresh the inactive list
              push     ActiveList
               xor     ActiveList, 1
               mov     ebx, ActiveList
               xor     esi, esi
            INVOKE     SendMessage, hWndListL[ebx*4], CM_GETSCROLLPOS, 0, 0
            .if eax
                  mov     esi, hWnd
            .endif
            INVOKE     LockWindowUpdate, esi
              call     Refresh
            INVOKE     SendMessage, hWndListL[ebx*4], CM_SETSCROLLPOS, 0, 0
            INVOKE     LockWindowUpdate, 0
               pop     ActiveList
              call     ChkTool
            INVOKE     SendMessage, hWnd, WM_PAINT, 0, 0
         .endif
      .endif
and     NotifyOn, 0
         ret

DoSHNotify ENDP

;===================================================
; Splitter Bar PROCEDURE
;===================================================
SplitBarProc PROC hdlg:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_INITDIALOG
          MOVmd     hSplitBar, hdlg

      .elseif wMsg == WM_CTLCOLORDLG
            jmp     ColorDlg

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax == IDCANCEL
               jmp     CancleIt
         .endif
      .endif
         jmp     DlgDone

ColorDlg:
      INVOKE     CreateSolidBrush, 0000ff00h
         mov     hBrush, eax
         ret

CancleIt:
      INVOKE     DeleteObject, hBrush
      INVOKE     DestroyWindow, hdlg
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE

DlgRet:
         ret

SplitBarProc ENDP

;===================================================
; Check splitter PROCEDURE
;===================================================
ChkSplitter PROC uses esi wParam:DWORD, lParam
LOCAL    rect:RECT
LOCAL    xPos:DWORD, yPos

;---------- [Capture the mouse if within an area] ----------
      INVOKE     GetClientRect, hWnd, addr rect
         mov     eax, lParam
         mov     edx, eax
         and     eax, 0ffffh
         inc     eax
         mov     xPos, eax
         shr     edx, 16
         inc     edx
         mov     yPos, edx
         mov     esi, dwTop
         sub     esi, 45

;SplitV         dd  0, 163, 165, 311, 478, 311
;SplitV        dd  0, 163, 165, 476, 478, 311
      .if eax >= SplitV[4] && eax <= SplitV[8] && edx > esi ||\
          eax >= SplitV[12] && eax <= SplitV[16] && edx > esi
         .if eax <= SplitV[8]
               mov     BarType, 1
         .else
               mov     BarType, 2
         .endif
         INVOKE     SetCursor, hSplit
         INVOKE     SetCapture, hWnd

      .else

;---------- [Release the mouse if out of the area] ----------
         .if wParam != MK_LBUTTON && wParam != MK_LBUTTON or MK_RBUTTON
               xor     esi, esi
            .if BarType == 1 || BarType == 2
                  lea     esi, SplitV
            .endif
            .if esi
               .if eax < [esi+4] || eax > [esi+8] || eax < [esi+12] || eax > [esi+16]
                     and     BarType, 0
                  INVOKE     ReleaseCapture
               .endif
            .endif
         .endif
         INVOKE     LoadCursor, 0, IDC_ARROW
         INVOKE     SetCursor, eax
      .endif

      .if wParam == MK_LBUTTON || wParam == MK_LBUTTON or MK_RBUTTON
         INVOKE     GetClientRect, hWnd, addr rect
            mov     ecx, xPos
            mov     edx, yPos
            add     rect.top, 106
            sub     rect.bottom, 20
         .if ecx > rect.left && ecx < rect.right && edx > rect.top && edx < rect.bottom
         .else
               jmp     Ret0
         .endif
;SplitV         dd  0, 163, 165, 311, 478, 311
;SplitV        dd  0, 163, 165, 476, 478, 311

;---------- [Create and drag the Splitter bar] ----------
         .if BarType == 1 || BarType == 2    ; Horizontal
            INVOKE     GetClientRect, hWnd, addr rect
            .if BarType == 1
                  mov     ecx, SplitV[16]
            .else
                  mov     ecx, rect.right
            .endif
            .if xPos < ecx
               INVOKE     SetCursor, hSplit
               .if !hSplitBar
                  INVOKE     CreateDialogParam, hInst, 4803, hWnd, offset SplitBarProc, 0
               .endif
                  mov     eax, xPos
                  dec     eax
;                  dec     eax
               .if BarType == 1
                     mov     SplitV[4], eax
                     add     eax, 2
                     mov     SplitV[8], eax
               .else
                     mov     SplitV[12], eax
                     add     eax, 2
                     mov     SplitV[16], eax
               .endif
               INVOKE     GetClientRect, hWndListL, addr rect
                 push     rect.bottom
               INVOKE     GetWindowRect, hWnd, addr rect
                  pop     rect.bottom
                  mov     eax, dwTop
                  add     rect.top, eax
                  add     rect.left, 4
                  mov     ecx, rect.left
               .if BarType == 1
                     add     ecx, SplitV[4]
               .else
                     add     ecx, SplitV[12]
               .endif
;                  inc     ecx
               INVOKE     MoveWindow, hSplitBar, ecx, rect.top, 2, rect.bottom, TRUE
            .endif
         .endif
      .endif

Ret0:
         ret
ChkSplitter ENDP

;===================================================
; About  PROCEDURE
;===================================================
AbVerDlg PROC uses ebx   hdlg:DWORD, wmsg, wparam, lparam
LOCAL    ms:MEMORYSTATUS
LOCAL    szBuff[32]:BYTE

      .if wmsg == WM_INITDIALOG
            mov     ms.dwLength, SIZEOF ms
         INVOKE     GlobalMemoryStatus, addr ms
         INVOKE     BaseAscii, ms.dwTotalPhys, addr szBuff, 10, 10, 1, 0, 1
         INVOKE     SetDlgItemText, hdlg, 22, addr szBuff
         INVOKE     BaseAscii, ms.dwAvailPhys, addr szBuff, 10, 10, 1, 0, 1
         INVOKE     SetDlgItemText, hdlg, 23, addr szBuff
         INVOKE     BaseAscii, ms.dwMemoryLoad, addr szBuff, 2, 10, 0, 0, 1
         INVOKE     SetDlgItemText, hdlg, 24, addr szBuff

      .elseif wmsg != WM_COMMAND
         jmp     DlgDone
      .endif
         mov     eax, wparam
         .if eax != IDOK
               jmp     DlgDone
         .endif

      INVOKE     EndDialog, hdlg, wparam
         mov     eax, TRUE
         jmp     DlgRet

DlgDone:
         mov     eax, FALSE

DlgRet:
         ret

AbVerDlg ENDP

;===================================================
; Registry Query for text strings
;===================================================
RegQuerySZ PROC ValueName:DWORD, Default
LOCAL    hRegQ:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegQ, addr lpdwDisp
      INVOKE     RegQueryValueEx, hRegQ, ValueName, 0, addr lpType, Default, addr lpcbData
        push     eax
      INVOKE     RegCloseKey, hRegQ
         pop     eax
         ret

RegQuerySZ  ENDP

;===================================================
; Return the integer value in eax from the registry
;===================================================
RegQuery PROC  uses ebx  ValueName:DWORD, Default
LOCAL     hRegQ:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegQ, addr lpdwDisp
         mov     lpcbData, 4
      INVOKE     RegQueryValueEx, hRegQ, ValueName, 0, addr lpType, Default, addr lpcbData
      INVOKE     RegCloseKey, hRegQ
         ret

RegQuery ENDP

;===================================================
; Registry set for text strings
;===================================================
RegSetSZ PROC ValueName:DWORD, Default
LOCAL    hRegS:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegS, addr lpdwDisp
      INVOKE     RegSetValueEx, hRegS, ValueName, 0, REG_SZ, Default, lpcbData
        push     eax
      INVOKE     RegCloseKey, hRegS
         pop     eax
         ret

RegSetSZ  ENDP

;===================================================
; Sets the integer value in the registry
;===================================================
RegSet PROC  uses ebx  ValueName:DWORD, Value
LOCAL     hRegS:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegS, addr lpdwDisp
         mov     lpcbData, 4
      INVOKE     RegSetValueEx, hRegS, ValueName, 0, REG_DWORD, Value, lpcbData
      INVOKE     RegCloseKey, hRegS
         ret

RegSet ENDP

;===================================================
; Saves information about FileMan to the registry
;===================================================
RegSave PROC  uses ebx esi edi
LOCAL    rect:RECT
LOCAL    hRegS:DWORD

      INVOKE     RegCreateKeyEx, HKEY_CURRENT_USER, addr szRedit, 0, addr szREGSZ, 0,\
                 KEY_WRITE or KEY_READ, 0, addr hRegS, addr lpdwDisp

        call     GetDesktopWindow
         mov     ecx, eax
      INVOKE     GetWindowRect, ecx, addr rect
         mov     esi, rect.right
         mov     edi, rect.bottom
         add     esi, 3
         add     edi, 2
      INVOKE     GetWindowRect, hWnd, addr rect
         cmp     esi, rect.right
          jl     NoSavePos              ; If window is maximized or past right
         cmp     edi, rect.bottom
          jl     NoSavePos              ; If window is maximized or past bottom
         mov     eax, rect.top
         shr     eax, 16
         cmp     eax, 0000ffffh
          je     NoSavePos              ; If window is minimized
         mov     eax, rect.left
         sub     rect.right, eax
         mov     eax, rect.top
         sub     rect.bottom, eax
       MOVmd     WndPos, rect.left
       MOVmd     WndPos+4, rect.top
       MOVmd     WndPos+8, rect.right
       MOVmd     WndPos+12, rect.bottom
      INVOKE     RegSetValueEx, hRegS, addr szWndPos, 0, REG_BINARY, addr WndPos, 16

NoSavePos:
         xor     ebx, ebx
      .while (ebx < 6)
         INVOKE     SendMessage, hWndListL, CM_GETCOLWIDTH, ebx, 0
            mov     ColWth[ebx*4], eax
            inc     ebx
      .endw

      INVOKE     RegSetValueEx, hRegS, addr ListPathL, 0, REG_SZ, addr szListPathL, sizeof szListPathL
      INVOKE     RegSetValueEx, hRegS, addr ListPathR, 0, REG_SZ, addr szListPathR, sizeof szListPathR
      INVOKE     RegSetValueEx, hRegS, addr ZipPack, 0, REG_SZ, addr szZipPack, sizeof szZipPack
      INVOKE     RegSetValueEx, hRegS, addr ZipUnPack, 0, REG_SZ, addr szZipUnPack, sizeof szZipUnPack
      INVOKE     RegSetValueEx, hRegS, addr PgmZip, 0, REG_SZ, addr szPgmZip, sizeof szPgmZip
      INVOKE     RegSetValueEx, hRegS, addr EditPgr, 0, REG_SZ, addr szEditPgr, sizeof szEditPgr
      INVOKE     RegSetValueEx, hRegS, addr WordPath, 0, REG_SZ, addr szWordPath, sizeof szWordPath
      INVOKE     RegSetValueEx, hRegS, addr szSortL, 0, REG_BINARY, addr SortL, sizeof SortL
      INVOKE     RegSetValueEx, hRegS, addr szSortR, 0, REG_BINARY, addr SortR, sizeof SortR
      INVOKE     RegSet, addr szActive, addr ActiveList
      INVOKE     RegSet, addr szShowGrid, addr ShowGrid
      INVOKE     RegSet, addr szShowHidden, addr ShowHidden
      INVOKE     RegSet, addr szShowConfC, addr ShowConfC
      INVOKE     RegSet, addr szShowConfD, addr ShowConfD
      INVOKE     RegSet, addr szShowProgess, addr ShowProgess
      INVOKE     RegSet, addr szShowProcess, addr ShowProcessed
      INVOKE     RegSet, addr szSaveOnExit, addr SaveOnExit
      INVOKE     RegSet, addr szCopyToRecyc, addr CopyToRecycle
      INVOKE     RegSet, addr szViewFlag, addr ViewFlag
      INVOKE     RegSet, addr szChkZip, addr ChkZip
      INVOKE     RegSet, addr szEqualOn, addr EqualOn

      INVOKE     RegSetValueEx, hRegS, addr szSplitV, 0, REG_BINARY, addr SplitV, sizeof SplitV
      INVOKE     RegSetValueEx, hRegS, addr szColWth, 0, REG_BINARY, addr ColWth, sizeof ColWth
      INVOKE     RegSetValueEx, hRegS, addr szFileManClrs, 0, REG_BINARY, addr Color.SelBarF, sizeof Color
      INVOKE     RegSetValueEx, hRegS, addr szCustClrs, 0, REG_BINARY, addr CustClrs, sizeof CustClrs

      INVOKE     RegCloseKey, hRegS
         ret

RegSave ENDP

end start
