
.data
szParent       db  'My Master',0

.data?
hParent        dd  ?
Lev            dd  ?
hItem          dd  ?
hItemT         dd  ?
hItemL         dd  ?
hItemR         dd  ?
ItemNew        dd  ?
hDrvExp        dd  ?
hDir           dd  32  dup(?)
hDrive         dd  32  dup(?)
PathLen        dd  32  dup(?)
hSubDir        dd  32  dup(?)

tvis           TV_INSERTSTRUCT      <?>

.code

;===================================================
; Initialize the Tree
;===================================================
InitTree PROC Code:DWORD, Input
LOCAL    cm:COLORMAP
LOCAL    tvi:TV_ITEM
LOCAL    sfi:SHFILEINFO

      INVOKE     CreateWindowEx, 0, offset StaticClass, NULL,\
                 WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or SS_OWNERDRAW or SS_NOTIFY,\
                 0, 0, 0, 0, hWnd, NULL, hInst, 0
         mov     hHeader, eax

      INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr TreeClass, NULL,\
                 WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or TVS_HASLINES or TVS_HASBUTTONS or\ 
                 TVS_LINESATROOT or TVS_SHOWSELALWAYS or TVS_TRACKSELECT,\
                 0, 0, 0, 0, hWnd, ID_TREEVIEW, hInst, NULL
      .if !eax
            mov     eax, -1
            ret
      .endif
         mov     hWndTree, eax
      INVOKE     SendMessage, hWndTree, WM_SETFONT, hFontM, TRUE
      INVOKE     SendMessage, hWndTree, TVM_SETTEXTCOLOR, 0, Color.TreeTC
      INVOKE     SendMessage, hWndTree, TVM_SETBKCOLOR, 0, Color.TreeBC

      INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 7, 10
         mov     hImageListTree, eax
         mov     cm.From, 00d08080h ;00ffffffh
         mov     eax, Color.TreeBC
         mov     cm.To, eax
      INVOKE     CreateMappedBitmap, hInst, 8002, 0, addr cm, 1
        push     eax
      INVOKE     ImageList_Add, hImageListTree, eax, NULL
         pop     eax
;;;;      INVOKE     DeleteObject, eax

      INVOKE     SendMessage, hWndTree, TVM_SETIMAGELIST, 0, hImageListTree

;      INVOKE     LockWindowUpdate, hWndTree          ; Lock parent to avoid flicker

         and     Lev, 0
         mov     byte ptr szDriveType, 'A'
      INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, TVI_ROOT
         mov     tvis.hParent, NULL
         mov     tvis.hInsertAfter, TVI_ROOT
         mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
         mov     tvis.item.pszText, offset szParent
         mov     tvis.item.iImage, 0
         mov     tvis.item.iSelectedImage, 0
      INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
         mov     ecx, Lev
         mov     hDrive[ecx*4], eax
         mov     hParent, eax

;---------- [Find available drives] ----------
      INVOKE     GetLogicalDrives
         mov     ebx, eax
         xor     edx, edx
      .while (ebx > 0)
            shr     ebx, 1
           push     edx
           push     ebx
         INVOKE     GetDriveType, addr szDriveType  ; Get type of drive
            pop     ebx
            pop     edx

;DRIVE_REMOVABLE  equ 2
;DRIVE_FIXED      equ 3
;DRIVE_REMOTE     equ 4
;DRIVE_CDROM      equ 5
;DRIVE_RAMDISK    equ 6
;---------- [If FIXED drive add the letter to the array] ----------
         .if eax == DRIVE_REMOVABLE || eax == DRIVE_FIXED || eax == DRIVE_CDROM ||\
             eax == DRIVE_REMOTE || eax == DRIVE_RAMDISK
               mov     ecx, eax
            .if ecx == DRIVE_REMOVABLE && byte ptr szDriveType > 'B'
                  mov     ecx, 4
            .elseif ecx == DRIVE_REMOTE
                  mov     ecx, 6
            .elseif ecx == DRIVE_RAMDISK
                  mov     ecx, 7
            .endif
               dec     ecx
               inc     edx
              push     edx
              push     ebx
               inc     Lev
               mov     eax, hParent
               mov     tvis.hParent, eax
               mov     tvis.hInsertAfter, TVI_LAST
              push     ecx
            INVOKE     SHGetFileInfo, addr szDriveType, 0, addr sfi, sizeof SHFILEINFO, SHGFI_DISPLAYNAME
               pop     ecx
               mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE or TVIF_CHILDREN
               lea     eax, sfi.szDisplayName
               mov     tvis.item.pszText, eax
               mov     tvis.item.iImage, ecx
               mov     tvis.item.iSelectedImage, ecx
               mov     tvis.item.cChildren, 1
            INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
               mov     hItem, eax
               mov     ebx, Lev
               mov     hDrive[ebx*4], eax
                pop     ebx
                pop     edx
         .endif
            inc     szDriveType
      .endw

         mov     tvis.item.iImage, 7 ;5
         mov     tvis.item.iSelectedImage, 8 ;6
         mov     tvis.item.cChildren, 0
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hParent
      INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, NULL
;      INVOKE     LockWindowUpdate, 0
      INVOKE     SetFocus, hWndTree

Ret0:
         xor     eax, eax
         ret

InitTree ENDP

;===========================================================
; Get the Directories and Sub Directories and build the Tree
;===========================================================
GetDirs PROC Code:DWORD, Input
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    tvi:TV_ITEM
LOCAL    Dirs:DWORD, Cnt, hFind
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE

      INVOKE     lstrcpy, addr szBuff0, Input
      INVOKE     FindFirstFile, addr szBuff0, addr FindData
        test     eax, eax
          js     NoFile
         mov     hFind, eax
         jmp     ChkDir

;_______________________________________________________________________
NextDir:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     AllDone ;GetDir

;_______________________________________________________________________
ChkDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         .if byte ptr FindData.cFileName == '.' ;|| dword ptr FindData.cFileName == 'YCER' 
               jmp     NextDir
         .endif
         .if Code == 1
            INVOKE     lstrlen, addr szBuff0
               sub     eax, 3
            INVOKE     lstrcpyn, addr szBuff1, addr szBuff0, eax
            INVOKE     lstrcat, addr szBuff1, addr szSlashB
         .else
;            INVOKE     lstrcpyn, addr szBuff1, addr szDir, 4
         .endif
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szAll
            mov     Lev, 0
         INVOKE     FillTree, addr FindData.cFileName, Code
            jmp     GetSubDir
      .endif
            jmp     NextDir

;_______________________________________________________________________
GetSubDir:
      INVOKE     FindFirstFile, addr szBuff1, addr FindData
      .if eax == -1
            mov     Lev, 0
            jmp     NextDir
      .endif
         mov     ecx, Lev
         mov     hSubDir[ecx*4], eax
         jmp     ChkSubDir

;_______________________________________________________________________
NextSubDir:
         mov     ecx, Lev
      INVOKE     FindNextFile, hSubDir[ecx*4], addr FindData
      .if !eax                       ; eax = 0 = failure
            mov     ecx, Lev   
         INVOKE     FindClose, hSubDir[ecx*4]
            mov     Lev, 0
            jmp     NextDir
      .endif

;_______________________________________________________________________
ChkSubDir:
      .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         .if byte ptr FindData.cFileName == '.'
               jmp     NextSubDir
         .endif
         INVOKE     lstrlen, addr szBuff1
            mov     ecx, Lev
            mov     PathLen[ecx*4], eax
            sub     eax, 2
         INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax
         INVOKE     lstrcat, addr szBuff1, addr FindData.cFileName
         INVOKE     lstrcat, addr szBuff1, addr szAll
            mov     ecx, Lev   
         INVOKE     FindClose, hSubDir[ecx*4]
            inc     Lev
         .if Lev < 2
               mov     eax, hItem
               mov     tvi.hItem, eax
               mov     tvi.imask, TVIF_CHILDREN
               mov     tvi.cChildren, 1
            INVOKE     SendMessage, hWndTree, TVM_SETITEM, 0, addr tvi
         .endif
            jmp     GetSubDir
      .endif
         jmp     NextSubDir

AllDone:
      INVOKE     FindClose, hFind

NoFile:
         xor     eax, eax
         ret

GetDirs ENDP

;===================================================
; Fill the Tree with Directories and Sub Directories
;===================================================
FillTree PROC uses ebx DirName:DWORD, Code

         mov     ebx, Lev   
         mov     eax, hDir[ebx*4]

      .if Lev == 0 && !Code
            mov     eax, hParent
      .elseif Lev == 0 && Code
            mov     eax, ItemNew
      .endif
         mov     tvis.hParent, eax
         mov     tvis.hInsertAfter, TVI_LAST
         mov     eax, DirName
         mov     tvis.item.pszText, eax
         mov     tvis.item.iImage, 7 ;5
         mov     tvis.item.iSelectedImage, 8 ;6
      INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
         mov     hItem, eax
         mov     ebx, Lev
         inc     ebx
         mov     hDir[ebx*4], eax

         xor     eax, eax
         ret

FillTree ENDP

;==============================================================
; Get Drive if root
;==============================================================
GetDrive PROC uses esi DrivePath:DWORD
LOCAL    szBuff[256]:byte

      INVOKE     lstrcpy, addr szBuff, DrivePath
      INVOKE     lstrlen, addr szBuff
         dec     eax
         mov     ecx, eax
      .while (ecx)
         .if byte ptr szBuff[ecx] == '(' && byte ptr szBuff[ecx+2] == ':'
               inc     ecx
            INVOKE     lstrcpyn, DrivePath, addr szBuff[ecx], 3
            INVOKE     lstrcat, DrivePath, addr szSlashB  ;N O T E !!! 01-05-2004
            .break
         .endif
            dec     ecx
      .endw
         xor     eax, eax   
      .if !ecx
            mov     eax, -1
      .endif
         ret

GetDrive ENDP

;===================================================
; Notify for the Treeview
;===================================================
TreeNotify PROC uses ebx esi edi lParam:DWORD
LOCAL    tvi:TV_ITEM
LOCAL    Sedi:DWORD, TreeCode
LOCAL    szWork1[64]:BYTE, szWork2[64], szBuff0[256], szBuff1[256]

            mov     eax, lParam
            mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
            mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
            mov     edx, (NM_TREEVIEW ptr [eax]).itemNew.state
            mov     esi, (NM_TREEVIEW ptr [eax]).itemOld.state
; States
; 01h = Focused
; 02h = Selected
; 20h = Edpanded
; 40h = ExpandedOnce
;DSPValue hWnd, esi, 1, 't'

      .if DragToTree
;          MOVmd     DragToTree, (NM_TREEVIEW ptr [eax]).itemOld.hItem
      .endif

      .if ebx == TVN_BEGINDRAG
           push     edx
           push     eax
          MOVmd     DragFrTree, (NM_TREEVIEW ptr [eax]).itemOld.hItem
            mov     hItemT, ecx
            mov     DragMode, 1
         INVOKE     SendMessage, hWndTree, TVM_CREATEDRAGIMAGE, 0, ecx
            mov     hDragImageList, eax
         INVOKE     ImageList_BeginDrag, hDragImageList, 0, 0, 0
            pop     eax
           push     eax
         INVOKE     ImageList_DragEnter, hWndTree, (NM_TREEVIEW ptr [eax]).ptDrag.x,\
                    (NM_TREEVIEW ptr [eax]).ptDrag.y
            pop     eax
           push     eax
            mov     edx, (NM_TREEVIEW ptr [eax]).ptDrag.x
            mov     tvht.pt.x, edx
            mov     edx, (NM_TREEVIEW ptr [eax]).ptDrag.y
            mov     tvht.pt.y, edx
         INVOKE     SetCapture, hWnd
         INVOKE     SendMessage, hWndTree, TVM_HITTEST, NULL, addr tvht
         .if eax
               mov     ecx, tvht.hItem
               mov     hItemT, ecx
         .endif
            pop     eax
            pop     edx
      .endif

      .if ebx == TVN_ITEMEXPANDING || ebx == TVN_SELCHANGING || ebx == TVN_BEGINDRAG
         .if ebx == TVN_SELCHANGING
           test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
             jz     Ret0
         .endif

;---------- [Retrive the path from the selected item] ----------
            and     TreeCode, 0
         .if edx && edx != TVIS_SELECTED || ebx == TVN_SELCHANGING || ebx == TVN_BEGINDRAG
               mov     TreeCode, 14
         .endif

            mov     hItem, ecx
            mov     ItemNew, ecx
            mov     tvi.hItem, ecx
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork1
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
           push     edx
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
            pop     edx
            mov     eax, hItem
         .if !edx && eax == hParent
               jmp     Ret0
         .endif

         INVOKE     GetDrive, addr szWork1
         .if eax != -1
;            INVOKE     lstrcat, addr szWork1, addr szSlashB
         .endif
            mov     eax, hItem

         .if byte ptr szWork1+1 == ':'
               mov     hDrvExp, eax
            INVOKE     lstrcpy, addr szBuff0, addr szWork1
            INVOKE     lstrcpy, addr szRootPath, addr szWork1
            INVOKE     lstrcat, addr szBuff0, addr szAll+1
               jmp     DriveHit
         .endif

            lea     edi, szBuff1
            add     edi, 250
            mov     byte ptr[edi], 0
            mov     byte ptr[edi-1], '\'
            sub     edi, 2
            mov     Sedi, edi
         .while (eax != hParent)
            INVOKE     lstrlen, addr szWork1
               mov     ebx, eax
               mov     ecx, eax
               mov     edi, Sedi
            .while (ecx)
                  mov     al, byte ptr szWork1[ebx-1]
                  mov     byte ptr[edi], al
                  dec     edi
                  dec     ebx
                  dec     ecx
            .endw

               mov     Sedi, edi
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_PARENT, hItem
               mov     hItem, eax
               mov     tvi.hItem, eax
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork1
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi

            INVOKE     GetDrive, addr szWork1
            .if eax != -1
;               INVOKE     lstrcat, addr szWork1, addr szSlashB
            .endif
               mov     eax, hItem
            .if byte ptr szWork1+1 != ':' && eax != hParent
                  mov     edi, Sedi
                  mov     byte ptr[edi], '\'
                  dec     edi
                  mov     Sedi, edi
            .endif
               mov     eax, hItem
         .endw
            mov     edi, Sedi
            lea     eax, szBuff1
            sub     edi, eax
            inc     edi
         INVOKE     lstrcpy, addr szBuff0, addr szBuff1[edi]
         INVOKE     lstrcpy, addr szRootPath, addr szBuff0
         INVOKE     lstrcat, addr szBuff0, addr szAll+1

DriveHit:
.if DragToTree || DragFrTree
;      mov     TreeCode, 0
;      jmp     Ret0
.endif
         .if TreeCode != 14
            INVOKE     GetDirs, 1, addr szBuff0
         .endif
            mov     eax, hItem
         .if eax != hParent
            INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, ItemNew
         .endif
         INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, ItemNew

      .elseif ebx == TVN_SELCHANGED
           test     (NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
             jz     Ret0
            mov     tvi.hItem, ecx
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork1
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi

         INVOKE     GetDrive, addr szWork1

            mov     byte ptr szBuff0, 0
         INVOKE     lstrlen, addr szWork1
         .if eax > 3 || byte ptr szWork1+1 != ':'                      ; Not root dir
            INVOKE     lstrcpy, addr szBuff0, addr szRootPath
         .else
            INVOKE     lstrcat, addr szBuff0, addr szWork1
            INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, tvi.hItem
         .endif
;         INVOKE     SendMessage, hWnd, WM_SETTEXT, 0, addr szBuff0
         .if !ActiveList
            INVOKE     lstrcpy, addr szListPathL, addr szBuff0
         .else
            INVOKE     lstrcpy, addr szListPathR, addr szBuff0
         .endif
           call     Refresh
      .endif

Ret0:
         xor     eax, eax   
         ret

TreeNotify ENDP

;==============================================================
; Expand Tree to proper branch converts a path to a tree handle
;==============================================================
TreeBranch PROC uses ebx esi
LOCAL    tvi:TV_ITEM
LOCAL    sci:SCROLLINFO
LOCAL    LevelCnt:DWORD, Cnt, Cnt1, dwState, Match, SavCnt
LOCAL    szPathTree[256]:byte, szWork1[64], szBuff[64], szTreeL[256]:byte, szTreeR[256]:byte

      .if ViewFlag == 310 || ViewFlag == 312
         .if ViewFlag == 310 && !CollaspeOn
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
              call     RemFileName
            INVOKE     lstrcpy, addr szTreeL, addr szRootPath
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
              call     RemFileName
            INVOKE     lstrcpy, addr szTreeR, addr szRootPath
            INVOKE     lstrcmpi, addr szTreeL, addr szTreeR
            .if !eax
                  and     CollaspeOn, 0
            .else
                  mov     CollaspeOn, 1
            .endif
         .endif

         .if !ActiveList
            INVOKE     lstrcpy, addr szRootPath, addr szListPathL
         .else
            INVOKE     lstrcpy, addr szRootPath, addr szListPathR
         .endif
      .else
            ret
      .endif
;INVOKE     MessageBox, NULL, addr szRootPath, addr AppName, MB_OK


.if CollaspeOn
      INVOKE     ValidateRect, hWnd, NULL
;      INVOKE     LockWindowUpdate, hWnd          ; Lock parent to avoid flicker
INVOKE     SendMessage, hWndTree, WM_SETREDRAW, 0, 0
.endif

         and     Cnt1, 0
         and     Match, 0
         and     LevelCnt, 0
      INVOKE     lstrcpy, addr szPathTree, addr szRootPath

;---------- [Get the number of levels in the path] ----------
         lea     esi, szPathTree
      .while (byte ptr[esi]) != 0
         .if byte ptr[esi] == '\'
               inc     LevelCnt
         .endif
         inc     esi
      .endw

        push     LevelCnt
         pop     SavCnt
         xor     esi, esi
         mov     Cnt, 30
      .while (Cnt)
            mov     al, byte ptr szPathTree
            add     al, 20h
         .if al == DriveArrayL[esi]
               mov     ebx, hDrive[esi*4+4]
            .if LevelCnt < 3 && ebx == hDrvExp && !GoBackOn
            .else
               .if CollaspeOn
                  INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_COLLAPSE or TVE_COLLAPSERESET, hDrvExp
               .endif
            .endif
               mov     hDrvExp, ebx
            .break
         .endif
            dec     Cnt
            inc     esi
      .endw
      .if !esi && byte ptr szPathTree != 'A' && !esi && byte ptr szPathTree != 'a'
            jmp     Ret0
      .endif

;---------- [Bypass the first path level] ----------
      INVOKE     lstrcpy, addr szPathTree, addr szPathTree+3
        push     hDrvExp
         pop     hItem

        push     hItem
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
         pop     hItem

      .if !eax && !hItem
            jmp     Ret0
      .endif
         mov     dwState, TVIS_BOLD
         inc     Cnt1
         inc     Match
         jmp     NextLev
         mov     ebx, 0

;---------- [Use the path to expand the tree] ----------
      .while (ebx <= LevelCnt)
         .if byte ptr szPathTree == 0   ; Last level
               mov     dwState, TVIS_SELECTED or TVIS_BOLD
         .endif

;------------------- [First child item of the tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CHILD, hItem
           test     eax, eax
             jz     DoError
            mov     hItem, eax
            mov     tvi.hItem, eax
            mov     tvi.imask, TVIF_TEXT
            lea     eax, szWork1
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
         INVOKE     lstrcmpi, addr szWork1, addr szBuff
         .if eax == 0
               jmp     SetChild
         .endif

;------------------- [Greater then first item of tree] -------------------
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .while (eax != 0) 
               mov     hItem, eax
               mov     tvi.hItem, eax
               mov     tvi.imask, TVIF_TEXT
               lea     eax, szWork1
               mov     tvi.pszText, eax
               mov     tvi.cchTextMax, 64
            INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
            INVOKE     lstrcmpi, addr szWork1, addr szBuff
            .if eax == 0
                  jmp     SetChild
            .endif
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_NEXT, hItem
         .endw
            jmp     NextLev

SetChild:
           push     hItem
         .if byte ptr szPathTree != 0    ; 0 = last folder
            INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hItem
         .endif
            pop     hItem
            mov     eax, hItem
            mov     tvi.hItem, eax
         .if byte ptr szPathTree != 0    ; 0 = last folder
               mov     tvi.imask, TVIF_CHILDREN
               mov     tvi.cChildren, 1
         .endif
         INVOKE     SendMessage, hWndTree, TVM_SETITEM, 0, addr tvi
            inc     Match

;------------------- [Get the directory for the next level] -------------------
NextLev:
            mov     ecx, Match
         .if byte ptr szPathTree == 0 && ecx == SavCnt
;            INVOKE     LockWindowUpdate, hWndTree
INVOKE     SendMessage, hWndTree, WM_SETREDRAW, 0, 0
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hItem
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_FIRSTVISIBLE, hItem
            INVOKE     SetWindowText, hStaticT, addr szNiceDay
            INVOKE     RedrawWindow, hStaticT, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT or RDW_UPDATENOW
               mov     sci.cbSize, sizeof sci
               mov     sci.fMask, SIF_ALL
            INVOKE     GetScrollInfo, hWndTree, SB_VERT, addr sci
;DSPValue hWnd, sci.nPos, 1, 't'
            .if sci.nPos > 10
                   sub     sci.nPos, 10
            .else
                   mov     sci.nPos, 0
            .endif

                     mov     eax, sci.nPos
                     shl     eax, 16
                     mov     ecx, SB_THUMBPOSITION
                     mov     ax, cx
                  INVOKE     SendMessage, hWndTree, WM_VSCROLL, eax, 0

;            INVOKE     SetScrollInfo, hWndTree, SB_VERT, addr sci, TRUE
;            INVOKE     LockWindowUpdate, 0
INVOKE     SendMessage, hWndTree, WM_SETREDRAW, 1, 0

;;;INVOKE     RedrawWindow, hWndTree, 0, 0, RDW_INVALIDATE or RDW_UPDATENOW
               jmp     Ret0

         .elseif byte ptr szPathTree == 0 && ecx != SavCnt
               jmp     DoError
         .endif
            mov     szBuff, 0
            xor     eax, eax
            lea     esi, szPathTree
         .while (byte ptr[esi]) != 0
            .if byte ptr[esi] == '\'
                  inc     eax
               INVOKE     lstrcpyn, addr szBuff, addr szPathTree, eax
                  inc     esi
               INVOKE     lstrcpy, addr szPathTree, esi
               .break
            .endif
               inc     eax
               inc     esi
         .endw
         .if byte ptr szBuff == 0
               jmp     Ret0
         .endif
            inc     Cnt1
            mov     ebx, Cnt1
      .endw
         jmp     Ret0

DoError:
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_COLLAPSE or TVE_COLLAPSERESET, hDrvExp
      INVOKE     MessageBox, NULL, addr szError2, szRootPath, MB_OK or MB_ICONINFORMATION
;      INVOKE     LockWindowUpdate, 0
INVOKE     SendMessage, hWndTree, WM_SETREDRAW, 1, 0
      INVOKE     InvalidateRect, hWnd, NULL, FALSE
         mov     eax, -1
         ret

Ret0:
.if !ActiveList
    MOVmd     hItemL, hItem
.else
    MOVmd     hItemR, hItem
.endif
.if CollaspeOn
      and     CollaspeOn, 0
;      INVOKE     LockWindowUpdate, 0
INVOKE     SendMessage, hWndTree, WM_SETREDRAW, 1, 0
      INVOKE     InvalidateRect, hWnd, NULL, FALSE
.endif
         xor     eax, eax

         ret

TreeBranch ENDP

;==============================================================
; Reset the current tree branch
;==============================================================
RefreshBranch PROC uses ebx esi edi
LOCAL    Cnt:DWORD
LOCAL    szPathTree[256]:byte

      INVOKE     lstrcpy, addr szRootPath, addr szBuffFr
        call     RemFileName
      INVOKE     lstrcpy, addr szBuffFr, addr szRootPath
      INVOKE     lstrcpy, addr szRootPath, addr szBuffTo
        call     RemFileName
      INVOKE     lstrcpy, addr szBuffTo, addr szRootPath
;INVOKE     MessageBox, NULL, addr szBuffFr, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szBuffTo, addr AppName, MB_OK

;DSPValue hWnd, HitList, 1, 'm'
;DSPValue hWnd, DragFrTree, 1, 'm'
;DSPValue hWnd, DropOn, 1, 'm'
;DSPValue hWnd, Funct, 1, 'm'

         mov     Cnt, 1
      .if Funct == IDM_MOVE
            mov     Cnt, 2
      .endif
      .while (Cnt)
         .if DropOn || DragFrTree
               mov     eax, HitList
            .if Funct == IDM_MOVE && Cnt == 1
                  xor     eax, 1
            .endif
               mov     esi, hItemL[eax*4]
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, esi
               mov     eax, esi
         .else
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CARET, 0
         .endif
;         .if DragFrTree
               mov     ItemNew, eax
;         .endif
            mov     esi, eax
         .if !esi
               jmp      Ret0
         .endif
         INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, esi
            mov     eax, esi
         .While (eax)
            INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CHILD, esi
            .if eax
               INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, eax
            .endif
;DSPValue hWnd, eax, 1, 'm'
         .endw

         .if Funct == IDM_DELETE || Funct == IDM_MOVE && Cnt == 1
            INVOKE     lstrcpy, addr szPathTree, addr szBuffFr
         .else
            INVOKE     lstrcpy, addr szPathTree, addr szBuffTo
         .endif
;INVOKE     MessageBox, NULL, addr szPathTree, addr AppName, MB_OK
         INVOKE     lstrcat, addr szPathTree, addr szAllFiles
         INVOKE     GetDirs, 1, addr szPathTree
           call     TreeBranch
            dec     Cnt
      .endw

Ret0:
         ret

RefreshBranch ENDP
